<?php
if (!defined('B_PROLOG_INCLUDED') || B_PROLOG_INCLUDED!==true)die();

use Bitrix\Main\Localization\Loc;
use Bitrix\Main\Web\Json;

if(!$arResult['BUTTON']['BACKGROUND_COLOR'])
{
	$arResult['BUTTON']['BACKGROUND_COLOR'] = '#00AEEF';
}

if(!$arResult['BUTTON']['ICON_COLOR'])
{
	$arResult['BUTTON']['ICON_COLOR'] = '#FFFFFF';
}

CJSCore::Init(array('clipboard'));
$APPLICATION->SetPageProperty(
	"BodyClass",
	$APPLICATION->GetPageProperty("BodyClass") . " no-paddings"
);



$getFormattedScript = function ($script)
{
	$script = htmlspecialcharsbx($script);
	$script = str_replace("\t", str_repeat('&nbsp;', 8), $script);
	return nl2br($script);
}
?>

<script>
	BX.ready(function(){
		new CrmButtonEditor(<?=Json::encode(array(
			'dictionaryPathEdit' => $arResult['BUTTON_ITEMS_DICTIONARY_PATH_EDIT']
		));?>);
	});
</script>

<form id="crm_button_main_form" method="post">
	<?=bitrix_sessid_post()?>



<?
function ShowIntranetButtonItemInterface($item)
{
	if(!$item)
	{
		return;
	}

	$type = htmlspecialcharsbx($item['TYPE']);
	$typeName = htmlspecialcharsbx($item['TYPE_NAME']);
	?>
	<div class="crm-button-edit-channel-lines-container <?=($item['ACTIVE'] == 'Y' ? "crm-button-edit-channel-lines-container-active" : "")?>" data-bx-crm-button-item="<?=$type?>">
		<div class="crm-button-edit-channel-lines-title-container">
			<div class="crm-button-edit-channel-lines-title-inner">
				<span class="crm-button-edit-channel-lines-title-icon crm-button-edit-channel-lines-title-icon-default-<?=$type?>"></span>
				<span class="crm-button-edit-channel-lines-title-item"><?=$typeName?>:</span>
			</div>
			<div class="crm-button-edit-channel-lines-title-activate-container <?=($item['ACTIVE'] == 'Y' ? 'crm-button-edit-channel-lines-title-on' : 'crm-button-edit-channel-lines-title-off')?>" data-bx-crm-button-item-active="<?=$type?>">
				<div class="crm-button-edit-channel-lines-title-activate-button-container">
					<span class="crm-button-edit-channel-lines-title-activate-button">
						<span class="crm-button-edit-channel-lines-title-activate-button-text"><?=Loc::getMessage('CRM_WEBFORM_EDIT_ON')?></span>
					</span>
					<span class="crm-button-edit-channel-lines-title-not-activate-button">
						<span class="crm-button-edit-channel-lines-title-activate-button-cursor"></span>
						<span class="crm-button-edit-channel-lines-title-not-activate-button-text"><?=Loc::getMessage('CRM_WEBFORM_EDIT_OFF')?></span>
					</span>
				</div>
			</div>

			<input type="hidden" data-bx-crm-button-item-active-val="<?=$type?>" name="ITEMS[<?=$type?>][ACTIVE]" value="<?=htmlspecialcharsbx($item['ACTIVE'])?>">

		</div><!--crm-button-edit-channel-lines-title-container-->
		<div class="crm-button-edit-channel-lines-inner-wrapper">
			<?if(count($item['LIST']) == 0):?>
				<div class="crm-button-edit-channel-make-line">
					<div class="crm-button-edit-channel-make-line-description">
						<span class="crm-button-edit-channel-make-line-description">
							<?=Loc::getMessage('CRM_WEBFORM_EDIT_CHANNEL_ADD_DESC')?>
						</span>
					</div>
					<div class="crm-button-edit-channel-make-line-button">
						<a href="<?=htmlspecialcharsbx($item['PATH_LIST'])?>" class="crm-button-edit-channel-make-line-button webform-small-button webform-small-button-blue">
							<?=Loc::getMessage('CRM_WEBFORM_EDIT_CHANNEL_SETUP')?>
						</a>
					</div>
				</div><!--crm-button-edit-channel-make-line-->
			<?else:?>
			<div class="crm-button-edit-channel-lines-inner-container">
				<div class="crm-button-edit-channel-lines-inner-create-container">
					<div class="crm-button-edit-channel-lines-inner-create-select-container">
						<select data-bx-crm-button-widget-select="<?=$type?>" id="ITEMS_<?=$type?>" name="ITEMS[<?=$type?>][EXTERNAL_ID]" class="crm-button-edit-channel-lines-inner-create-select-item">
							<?foreach($item['LIST'] as $external):?>
								<option value="<?=htmlspecialcharsbx($external['ID'])?>" <?=($external['SELECTED'] ? 'selected' : '')?>>
									<?=htmlspecialcharsbx($external['NAME'])?>
								</option>
							<?endforeach;?>
						</select>
						<div class="crm-button-edit-channel-lines-inner-create-select-triangle">
							<span class="crm-button-edit-channel-lines-inner-create-select-triangle-item"></span>
						</div>
					</div>
					<div class="crm-button-edit-channel-lines-inner-create-button-container">
						<a data-bx-crm-button-widget-btn-edit="<?=$type?>" href="" class="crm-button-edit-channel-lines-inner-create-button-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_CHANNEL_EDIT')?></a>
						<?if($item['PATH_ADD']):?>
							<a href="<?=htmlspecialcharsbx($item['PATH_ADD'])?>" class="crm-button-edit-channel-lines-inner-create-button-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_CHANNEL_ADD')?></a>
						<?endif;?>
					</div>
				</div><!--crm-button-edit-channel-lines-inner-create-container-->

			</div><!--crm-button-edit-channel-lines-inner-container-->
			<div class="crm-button-edit-channel-lines-display-options-container">
				<div class="crm-button-edit-channel-lines-display-options-inner-container">
					<div class="crm-button-edit-channel-lines-display-options-title-container">
						<span class="crm-button-edit-channel-lines-display-options-title-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_PAGE_SETTINGS')?>:</span>
					</div>
					<div class="crm-button-edit-channel-lines-display-options-settings-container">
						<div class="crm-button-edit-channel-lines-display-options-settings-button-container">
							<span data-crm-button-item-settings-btn="<?=$type?>" class="crm-button-edit-channel-lines-display-options-settings-button">
								<?=Loc::getMessage('CRM_WEBFORM_EDIT_PAGE_SETTINGS_SETUP')?>
							</span>
							<span class="crm-button-edit-channel-lines-display-options-settings-triangle">
								<span class="crm-button-edit-channel-lines-display-options-settings-triangle-item"></span>
							</span>
						</div>
						<div class="crm-button-edit-channel-lines-display-options-settings-descriptions-container">
							<span class="crm-button-edit-channel-lines-display-options-settings-item">
								<?if($item['PAGES_USES']):?>
									<?=Loc::getMessage('CRM_WEBFORM_EDIT_PAGE_SETTINGS_USER')?>
								<?else:?>
									<?=Loc::getMessage('CRM_WEBFORM_EDIT_PAGE_SETTINGS_DEFAULT')?>
								<?endif;?>
							</span>
						</div>
					</div>
				</div><!--crm-button-edit-channel-lines-display-options-inner-container-->
				<div data-crm-button-item-settings="<?=$type?>" class="crm-button-edit-channel-lines-display-options-links-container">
					<div class="crm-button-edit-channel-lines-display-options-links-for-all-container">

						<label for="ITEMS_<?=$type?>_PAGES_MODE_EXCLUDE" class="crm-button-edit-channel-lines-display-options-links-button-container">
							<input id="ITEMS_<?=$type?>_PAGES_MODE_EXCLUDE" class="crm-button-edit-channel-lines-display-options-links-button-item" type="radio" name="ITEMS[<?=$type?>][PAGES][MODE]" value="EXCLUDE" <?=($item['PAGES']['MODE'] != 'INCLUDE' ? 'checked' : '')?>>
							<span class="crm-button-edit-channel-lines-display-options-links-button-description"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SHOW_ON_ALL_PAGES')?>:</span>
						</label>

						<?ShowIntranetButtonItemPageInterface($type, $item['PAGES']['LIST']['EXCLUDE'], 'EXCLUDE');?>
					</div><!--crm-button-edit-channel-lines-display-options-links-for-all-container-->
					<div class="crm-button-edit-channel-lines-display-options-links-specified-container">
						<label for="ITEMS_<?=$type?>_PAGES_MODE_INCLUDE" class="crm-button-edit-channel-lines-display-options-links-button-container">
							<input class="crm-button-edit-channel-lines-display-options-links-button-item" type="radio" id="ITEMS_<?=$type?>_PAGES_MODE_INCLUDE" name="ITEMS[<?=$type?>][PAGES][MODE]" value="INCLUDE" <?=($item['PAGES']['MODE'] == 'INCLUDE' ? 'checked' : '')?>>
							<span class="crm-button-edit-channel-lines-display-options-links-button-description"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SHOW_ONLY_PAGES')?>:</span>
						</label>

						<?ShowIntranetButtonItemPageInterface($type, $item['PAGES']['LIST']['INCLUDE'], 'INCLUDE');?>
					</div><!--crm-button-edit-channel-lines-display-options-links-specified-container-->
					<div class="crm-button-edit-channel-lines-display-options-links-description-container">
						<div class="crm-button-edit-channel-lines-display-options-links-description-info">
							<span class="crm-button-edit-channel-lines-display-options-links-description-info-item">&#063;</span>
						</div>
						<span class="crm-button-edit-channel-lines-display-options-links-description-text">
							<?=nl2br(Loc::getMessage('CRM_WEBFORM_EDIT_HINT_ANY'))?>
						</span>
					</div><!--crm-button-edit-channel-lines-display-options-links-description-container-->
				</div><!--crm-button-edit-channel-lines-display-options-links-container-->
			</div><!--crm-button-edit-channel-lines-display-options-container-->
			<?endif;?>
		</div><!--crm-button-edit-channel-lines-inner-wrapper-->
	</div><!--crm-button-edit-channel-lines-container-->
	<?
}

function ShowIntranetButtonItemPage($type, $mode, $page)
{
	?>
	<div data-crm-button-item-pages-page="null" class="crm-button-edit-item-pages-page crm-button-edit-channel-lines-display-options-links-block">
		<input placeholder="http://example.com/dir/page" type="text" name="ITEMS[<?=$type?>][PAGES][LIST][<?=$mode?>][]" value="<?=$page?>" class="crm-button-edit-channel-lines-display-options-links-block-item">

		<div class="crm-button-edit-item-pages-btn-add crm-button-edit-channel-lines-display-options-links-block-button">
			<span data-crm-button-item-pages-btn-add="" class="crm-button-edit-channel-lines-display-options-links-block-button-item crm-button-edit-add-icon"></span>
		</div>
		<div class="crm-button-edit-item-pages-btn-del crm-button-edit-channel-lines-display-options-links-block-button">
			<span data-crm-button-item-pages-btn-del="" class="crm-button-edit-channel-lines-display-options-links-block-button-item crm-button-edit-close-icon"></span>
		</div>
	</div>
	<?
}

function ShowIntranetButtonItemPageInterface($type, $list, $mode)
{
	if(!is_array($list) || count($list) == 0)
	{
		$list = array('');
	}

	$mode = htmlspecialcharsbx($mode);

	?>
	<div data-crm-button-item-pages="null">
		<script type="text/template">
			<?ShowIntranetButtonItemPage($type, $mode, '');?>
		</script>
		<div data-crm-button-item-pages-list="null">
		<?
		foreach ($list as $page)
		{
			$page = htmlspecialcharsbx($page);
			ShowIntranetButtonItemPage($type, $mode, $page);
		}
		?>
		</div>
	</div>
	<?
}
?>

	<div class="crm-button-edit-return-back">
		<a href="<?=htmlspecialcharsbx($arResult['PATH_TO_BUTTON_LIST'])?>" class="crm-button-edit-return-back-item">&larr; <?=Loc::getMessage('CRM_WEBFORM_EDIT_SELECT_BACK_TO_BUTTON_LIST')?></a>
		<?
		foreach ($arResult['ERRORS'] as $error)
		{
			ShowError($error);
		}
		?>
	</div>

<div class="crm-button-edit-container">


	<?$this->SetViewTarget('sidebar');?>
	<form id="crm_button_sub_form">
	<div class="crm-button-edit-right-container">
		<div class="crm-button-edit-sidebar-title">
			<span class="crm-button-edit-sidebar-title-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SHOW_VIEW')?>:</span>
		</div><!--crm-button-edit-sidebar-title-->
		<div id="BUTTON_COLOR_CONTAINER">
			<div class="crm-button-edit-sidebar-button-preview-container">
				<div class="crm-button-edit-sidebar-button-preview-inner">
					<?
					$APPLICATION->IncludeComponent("bitrix:crm.button.button", ".default", array(
						'PREVIEW' => true,
						'LOCATION' => 1,
						'COLOR_ICON' => $arResult['BUTTON']['ICON_COLOR'],
						'COLOR_BACKGROUND' => $arResult['BUTTON']['BACKGROUND_COLOR'],
					));
					?>
				</div>
			</div><!--crm-button-edit-sidebar-button-preview-container-->
			<div class="crm-button-edit-sidebar-button-colorpicker-container">
				<div class="crm-button-edit-sidebar-button-colorpicker-inner">
					<div class="crm-button-edit-sidebar-button-colorpicker-block">
						<span class="crm-webform-edit-left-field-colorpick-text-container">
							<input size="7" id="BACKGROUND_COLOR" data-web-form-color-picker="" type="hidden" name="BACKGROUND_COLOR" value="<?=htmlspecialcharsbx($arResult['BUTTON']['BACKGROUND_COLOR'])?>">
							<span class="crm-webform-edit-left-field-colorpick-background-circle"></span>
							<span class="crm-web-form-color-picker crm-webform-edit-left-field-colorpick-background"><?=Loc::getMessage('CRM_BUTTON_EDIT_COLOR_BG')?></span>
						</span>

						<span class="crm-webform-edit-left-field-colorpick-text-container">
							<input size="7" id="ICON_COLOR" data-web-form-color-picker="" type="hidden" name="ICON_COLOR" value="<?=$arResult['BUTTON']['ICON_COLOR']?>">
							<span class="crm-webform-edit-left-field-colorpick-text-circle"></span>
							<span class="crm-web-form-color-picker crm-webform-edit-left-field-colorpick-text"><?=Loc::getMessage('CRM_BUTTON_EDIT_COLOR_ICON')?></span>
						</span>

						<?$APPLICATION->IncludeComponent(
							"bitrix:main.colorpicker",
							"",
							Array(
								"COMPONENT_TEMPLATE" => ".default",
								"ID" => "",
								"NAME" => "",
								"ONSELECT" => "",
								"SHOW_BUTTON" => "N"
							)
						);?>
					</div>
				</div>
			</div><!--crm-button-edit-sidebar-button-preview-container-->
		</div>
		<div class="crm-button-edit-sidebar-title">
			<span class="crm-button-edit-sidebar-title-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SHOW_CHOOSE_LOCATION')?>:</span>
		</div><!--crm-button-edit-sidebar-title-->
		<div id="LOCATION_CONTAINER" class="crm-button-edit-sidebar-button-position-container">
			<div class="crm-button-edit-sidebar-button-position-header">
				<div class="crm-button-edit-sidebar-button-position-header-dots">
					<span class="crm-button-edit-sidebar-button-position-header-dots-item"></span>
					<span class="crm-button-edit-sidebar-button-position-header-dots-item"></span>
					<span class="crm-button-edit-sidebar-button-position-header-dots-item"></span>
				</div>
				<div class="crm-button-edit-sidebar-button-position-header-line"></div>
			</div>
			<div class="crm-button-edit-sidebar-button-position-inner">
				<?foreach($arResult['BUTTON_LOCATION'] as $location):
					?>
					<label for="LOCATION_<?=htmlspecialcharsbx($location['ID'])?>" data-bx-crm-button-loc="" class="crm-button-edit-sidebar-button-position-block <?if($location['SELECTED']):?>crm-button-edit-sidebar-button-position-block-active-<?=htmlspecialcharsbx($location['ID'])?><?endif;?>" title="<?=htmlspecialcharsbx($location['NAME'])?>">
						<span class="crm-button-edit-arrow crm-button-edit-sidebar-button-position-arrow-<?=htmlspecialcharsbx($location['ID'])?>"></span>
						<input data-bx-crm-button-loc-val="" id="LOCATION_<?=htmlspecialcharsbx($location['ID'])?>" class="crm-button-edit-sidebar-button-position-block-item" type="radio" name="LOCATION" value="<?=htmlspecialcharsbx($location['ID'])?>" <?=($location['SELECTED'] ? 'checked' : '')?>>
					</label>
				<?endforeach?>
			</div>
		</div><!--crm-button-edit-sidebar-button-position-container-->
		<div class="crm-button-edit-sidebar-title">
			<span class="crm-button-edit-sidebar-title-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SHOW_DELAY')?>:</span>
		</div><!--crm-button-edit-sidebar-title-->
		<div class="crm-button-edit-sidebar-show-container">
			<div class="crm-button-edit-sidebar-show-inner">
				<div class="crm-button-edit-sidebar-show-item">
					<input type="radio" id="DELAY_CHOISE_NONE" name="DELAY_CHOISE" value="N" <?=($arResult['BUTTON']['DELAY'] <= 0 ? 'checked' : '')?>>
					<label for="DELAY_CHOISE_NONE"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SHOW_DELAY_AT_ONCE')?></label>
				</div>
				<br>
				<br>
				<span class="crm-button-edit-sidebar-show-item">
					<input type="radio" id="DELAY_CHOISE_TIME" name="DELAY_CHOISE" value="Y" <?=($arResult['BUTTON']['DELAY'] > 0 ? 'checked' : '')?>>
					<label for="DELAY_CHOISE_TIME"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SHOW_DELAY_DELAY')?></label>
				</span>
				<div class="crm-button-edit-sidebar-show-delay-container">
					<select class="crm-button-edit-sidebar-show-delay" name="DELAY">
						<?foreach($arResult['BUTTON_DELAY'] as $delayItem):?>
							<option value="<?=htmlspecialcharsbx($delayItem['ID'])?>" <?=($delayItem['SELECTED'] ? 'selected' : '')?>>
								<?=htmlspecialcharsbx($delayItem['NAME'])?>
							</option>
						<?endforeach?>
					</select>
					<div class="crm-button-edit-channel-lines-inner-create-select-triangle">
						<span class="crm-button-edit-channel-lines-inner-create-select-triangle-item"></span>
					</div>
				</div><!--crm-button-edit-sidebar-show-delay-container-->
			</div>
		</div><!--crm-button-edit-sidebar-show-container-->

		<?if($arParams['ELEMENT_ID']):?>
			<div class="crm-button-edit-sidebar-title">
				<span class="crm-button-edit-sidebar-title-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SITE_SCRIPT')?></span>
				<span class="crm-button-context-help" data-text="<?=htmlspecialcharsbx(Loc::getMessage("CRM_WEBFORM_EDIT_SITE_SCRIPT_TIP"))?>">?</span>
			</div><!--crm-button-edit-sidebar-title-->

			<div id="SCRIPT_CONTAINER" class="crm-button-edit-sidebar-insert-code-container">
				<div class="crm-button-edit-sidebar-insert-code-inner">
						<div data-bx-webform-script-copy-text class="crm-button-edit-sidebar-insert-code-item" style="width: 100%; height: 200px;"><?=$getFormattedScript($arResult['SCRIPT'])?></div>
				</div>
				<div class="crm-button-edit-sidebar-insert-code-button">
					<a data-bx-webform-script-copy-btn="" class="crm-button-edit-sidebar-insert-code-button-item webform-small-button webform-small-button-blue">
						<?=Loc::getMessage('CRM_WEBFORM_EDIT_COPY_TO_CLIPBOARD')?>
					</a>
				</div>
			</div><!--crm-button-edit-sidebar-insert-code-container-->
		<?endif;?>
	</div><!--crm-button-edit-right-container-->
	</form>
	<?$this->EndViewTarget();?>

	<div class="crm-button-edit-left-container">
		<div class="crm-button-edit-button-name-container">
			<div class="crm-button-edit-button-name">
				<input type="text" name="NAME" value="<?=htmlspecialcharsbx($arResult['BUTTON']['NAME'])?>" placeholder="<?=Loc::getMessage('CRM_WEBFORM_EDIT_NAME_PLACEHOLDER')?>" class="crm-button-edit-button-item">
			</div>
		</div>
		<div class="crm-button-edit-border"></div><!--crm-button-edit-border-->
		<div class="crm-button-edit-channel-container">
			<div class="crm-button-edit-channel-description-container">
				<div class="crm-button-edit-channel-description-item">
					<?=nl2br(Loc::getMessage('CRM_WEBFORM_EDIT_DESC'))?>
				</div>
			</div><!--"crm-button-edit-channel-description-container-->
			<div class="crm-button-edit-channel-title-container">
				<span class="crm-button-edit-channel-title-item"><?=Loc::getMessage('CRM_WEBFORM_EDIT_CHANNELS')?></span>
			</div><!--crm-button-edit-channel-title-container-->

			<div id="WIDGET_CONTAINER">
				<?
				ShowIntranetButtonItemInterface($arResult['BUTTON_ITEM_OPEN_LINE']);
				ShowIntranetButtonItemInterface($arResult['BUTTON_ITEM_CRM_FORM']);
				ShowIntranetButtonItemInterface($arResult['BUTTON_ITEM_CALLBACK']);
				?>
			</div>

		</div><!--crm-button-edit-channel-container-->
		<div class="crm-button-edit-left-send-container">
			<div class="crm-button-edit-left-send-inner">
				<input type="submit" class="crm-button-edit-left-send-confirm webform-small-button webform-small-button-accept" value="<?=Loc::getMessage('CRM_WEBFORM_EDIT_SAVE')?>">
				<a href="<?=htmlspecialcharsbx($arResult['PATH_TO_BUTTON_LIST'])?>" class="crm-button-edit-left-send-back webform-small-button webform-small-button-transparent"><?=Loc::getMessage('CRM_WEBFORM_EDIT_SELECT_BACK_TO_LIST')?></a>
			</div>
		</div><!---crm-button-edit-left-send-container->
	</div><!--crm-button-edit-left-container-->

</div><!--crm-button-edit-container-->


</form>