<?php
use Bitrix\Main\Loader;
use Bitrix\Main\Context;
use Bitrix\Crm\SiteButton\Button;
use Bitrix\Main\Localization\Loc;

define('STOP_STATISTICS', true);
define('BX_SECURITY_SHOW_MESSAGE', true);

require_once($_SERVER['DOCUMENT_ROOT'].'/bitrix/modules/main/include/prolog_before.php');

if (!Loader::includeModule('crm'))
{
	return;
}

Loc::loadMessages(__FILE__);

class CrmSiteButtonListAjaxController extends \Bitrix\Crm\SiteButton\ComponentController
{
	protected function getActions()
	{
		return array(
			'activate',
			'deactivate',
			'delete',
			'copy',
		);
	}

	protected function activate()
	{
		global $USER;
		if(!Button::activate($this->requestData['BUTTON_ID'], true, $USER->GetID()))
		{
			$this->errors[] = '';
		}
	}

	protected function deactivate()
	{
		global $USER;
		if(!Button::activate($this->requestData['BUTTON_ID'], false, $USER->GetID()))
		{
			$this->errors[] = '';
		}
	}

	protected function delete()
	{
		if(!Button::delete($this->requestData['BUTTON_ID']))
		{
			$this->errors[] = '';
		}
	}

	protected function copy()
	{
		global $USER;
		$copiedId = Button::copy($this->requestData['BUTTON_ID'], $USER->GetID());
		if(!$copiedId)
		{
			$this->errors[] = '';
		}
		else
		{
			$this->responseData['copiedId'] = $copiedId;
		}
	}

	protected function checkPermissions()
	{
		/**@var $USER \CUser*/
		global $USER;
		$CrmPerms = new CCrmPerms($USER->GetID());
		return !$CrmPerms->HavePerm('BUTTON', BX_CRM_PERM_NONE, 'WRITE');
	}

	protected function prepareRequestData()
	{
		$this->requestData = array(
			'BUTTON_ID' => intval($this->request->get('button_id'))
		);
	}
}

$controller = new CrmSiteButtonListAjaxController();
$controller->exec();