<?php
if (!defined('B_PROLOG_INCLUDED') || B_PROLOG_INCLUDED!==true)die();

use Bitrix\Main\Web\Json;
use Bitrix\Main\Localization\Loc;

/** @var CBitrixComponentTemplate $this */
/** @var array $arParams */
/** @var array $arResult */

CJSCore::Init(array('clipboard'));
?>

<div class="intranet-button-list-wrapper">

	<div class="intranet-button-list-info">
		<h2 class="intranet-button-list-info-title"><?=Loc::getMessage('CRM_BUTTON_LIST_INFO_TITLE')?></h2>
		<span class="intranet-button-list-info-descroption"><?=Loc::getMessage('CRM_BUTTON_LIST_INFO_DESC')?></span>
		<div class="intranet-button-list-info-list-container">
			<ul class="intranet-button-list-info-list">
				<li class="intranet-button-list-info-list-item">
					<?=Loc::getMessage('CRM_BUTTON_LIST_INFO_DESC_ITEM_1')?>
				</li>
				<li class="intranet-button-list-info-list-item">
					<?=Loc::getMessage('CRM_BUTTON_LIST_INFO_DESC_ITEM_2')?>
				</li>
				<li class="intranet-button-list-info-list-item">
					<?=Loc::getMessage('CRM_BUTTON_LIST_INFO_DESC_ITEM_3')?>
				</li>
				<li class="intranet-button-list-info-list-item">
					<?=Loc::getMessage('CRM_BUTTON_LIST_INFO_DESC_ITEM_4')?>
				</li>
				<li class="intranet-button-list-info-list-item">
					<?=Loc::getMessage('CRM_BUTTON_LIST_INFO_DESC_ITEM_5')?>
				</li>
			</ul>
		</div>
	</div>

	<?if($arResult['PERM_CAN_EDIT']):?>
	<a href="<?=htmlspecialcharsbx($arResult['PATH_TO_BUTTON_NEW'])?>">
		<div class="crm-button-list-createbutton-container">
			<div class="crm-button-list-createbutton-element"><?=Loc::getMessage('CRM_BUTTON_LIST_ADD_CAPTION')?></div>
			<span class="crm-button-list-createbutton-description"><?=Loc::getMessage('CRM_BUTTON_LIST_ADD_DESC1')?></span>
		</div>
	</a>
	<?endif;?>

	<div id="crm_web_form_list_container">
	<!--intranet-button-list-createform-container-->
<?foreach($arResult['ITEMS_BY_IS_SYSTEM'] as $isSystem => $system):?>
	<div class="intranet-button-list-header-container">
		<h3 class="intranet-button-list-header"><?=htmlspecialcharsbx($system['NAME'])?></h3>
	</div><!--intranet-button-list-header-container-->

<?foreach($system['ITEMS'] as $item):
	$isSystem = $item['IS_SYSTEM'];
	?>
	<div class="intranet-button-list-widget-row"
		data-bx-crm-webform-item="<?=intval($item['ID'])?>"
		data-bx-crm-webform-item-is-system="<?=$isSystem?>"
	>
		<div class="intranet-button-list-buttons-container">
			<div class="intranet-button-list-buttons">
				<span class="intranet-button-list-hamburger" data-bx-crm-webform-item-settings=""></span>
				<?if($arResult['PERM_CAN_EDIT'] && $isSystem != 'Y'):?>
					<span class="intranet-button-list-close" data-bx-crm-webform-item-delete="" title="<?=Loc::getMessage('CRM_BUTTON_LIST_ACTIONS_REMOVE')?>"></span>
				<?endif;?>
			</div><!--intranet-button-list-buttons-->
		</div><!--intranet-button-list-button-container-->
		<div class="intranet-button-list-widget-container intranet-button-list-widget-left">
			<div class="intranet-button-list-widget intranet-button-list-widget-number <?=$item['viewClassName']?>" data-bx-crm-webform-item-view="">
				<div class="intranet-button-list-widget-head">
					<span class="intranet-button-list-widget-title-container">
						<span class="intranet-button-list-widget-title-inner">
							<a href="<?=htmlspecialcharsbx($item['PATH_TO_BUTTON_EDIT'])?>">
							<span class="intranet-button-list-widget-title"><?=htmlspecialcharsbx($item['NAME'])?></span>
							</a>
						</span>
					</span>
				</div><!--intranet-button-list-widget-head-->
				<div class="intranet-button-list-widget-content">
					<div class="intranet-button-list-widget-content-amt">
						<div class="intranet-button-list-widget-content-inner">
							<div class="intranet-button-list-widget-content-inner-block" title="<?=htmlspecialcharsbx($arResult['TYPE_LIST']['openline'])?>">
								<?if($item['ITEMS']['openline']):?>
									<div class="intranet-button-list-widget-content-inner-item intranet-button-list-widget-active">
										<div class="intranet-button-list-widget-content-inner-item-image intranet-button-list-openlines"></div>
										<div class="intranet-button-list-widget-content-inner-item-text"><?=htmlspecialcharsbx($item['ITEMS']['openline']['NAME'])?></div>
									</div><!--intranet-button-list-widget-content-inner-item-->
								<?else:?>
									<div class="intranet-button-list-widget-content-inner-item">
										<div class="intranet-button-list-widget-content-inner-item-image intranet-button-list-openlines"></div>
										<div class="intranet-button-list-widget-content-inner-item-text"><?=Loc::getMessage('CRM_BUTTON_LIST_NOT_SELECTED')?></div>
									</div><!--intranet-button-list-widget-content-inner-item-->
								<?endif;?>
							</div><!--intranet-button-list-widget-content-inner-item-->
							<div class="intranet-button-list-widget-content-inner-block" title="<?=htmlspecialcharsbx($arResult['TYPE_LIST']['crmform'])?>">
								<?if($item['ITEMS']['crmform']):?>
									<div class="intranet-button-list-widget-content-inner-item intranet-button-list-widget-active">
										<div class="intranet-button-list-widget-content-inner-item-image intranet-button-list-webform"></div>
										<div class="intranet-button-list-widget-content-inner-item-text"><?=htmlspecialcharsbx($item['ITEMS']['crmform']['NAME'])?></div>
									</div><!--intranet-button-list-widget-content-inner-item-->
								<?else:?>
									<div class="intranet-button-list-widget-content-inner-item">
										<div class="intranet-button-list-widget-content-inner-item-image intranet-button-list-webform"></div>
										<div class="intranet-button-list-widget-content-inner-item-text"><?=Loc::getMessage('CRM_BUTTON_LIST_NOT_SELECTED')?></div>
									</div><!--intranet-button-list-widget-content-inner-item-->
								<?endif;?>
							</div><!--intranet-button-list-widget-content-inner-item-->
							<div class="intranet-button-list-widget-content-inner-block" title="<?=htmlspecialcharsbx($arResult['TYPE_LIST']['callback'])?>">
								<?if($item['ITEMS']['callback']):?>
									<div class="intranet-button-list-widget-content-inner-item intranet-button-list-widget-active">
										<div class="intranet-button-list-widget-content-inner-item-image intranet-button-list-call"></div>
										<div class="intranet-button-list-widget-content-inner-item-text"><?=htmlspecialcharsbx($item['ITEMS']['callback']['NAME'])?></div>
									</div><!--intranet-button-list-widget-content-inner-item-->
								<?else:?>
									<div class="intranet-button-list-widget-content-inner-item">
										<div class="intranet-button-list-widget-content-inner-item-image intranet-button-list-call"></div>
										<div class="intranet-button-list-widget-content-inner-item-text"><?=Loc::getMessage('CRM_BUTTON_LIST_NOT_SELECTED')?></div>
									</div><!--intranet-button-list-widget-content-inner-item-->
								<?endif;?>
							</div><!--intranet-button-list-widget-content-inner-item-->
						</div><!--intranet-button-list-widget-content-inner-->
					</div>
				</div><!--intranet-button-list-widget-content-->
			</div><!--intranet-button-list-widget intranet-button-list-widget-number-->
		</div><!--intranet-button-list-widget-container intranet-button-list-widget-left-->
		<div class="intranet-button-list-widget-container intranet-button-list-widget-right">

			<div class="intranet-button-list-inner-info-container">
				<div class="intranet-button-list-creation-date-container">
					<div class="intranet-button-list-creation-date-element">
						<span class="intranet-button-list-text"><?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_DATE_CREATE')?>:</span>
						<span class="intranet-button-list-date"><?=htmlspecialcharsbx($item['DATE_CREATE_DISPLAY'])?></span>
					</div>
				</div><!--intranet-button-list-creation-date-container-->
				<div class="intranet-button-list-position-container">
					<div class="intranet-button-list-position-element">
						<span class="intranet-button-list-position-inner-wrap">
							<span class="intranet-button-list-position-text"><?=Loc::getMessage('CRM_BUTTON_LIST_LOCATION')?>:</span>
							<span class="intranet-button-list-position-text"><?=htmlspecialcharsbx(strtolower($item['LOCATION_DISPLAY']))?></span>
						</span>
					</div>
				</div><!--intranet-button-list-url-container-->
				<div class="intranet-button-list-settings-container">
					<div class="intranet-button-list-settings-element">
						<span class="intranet-button-list-settings-text"><?=Loc::getMessage('CRM_BUTTON_LIST_VIEW')?>:</span>
						<span class="intranet-button-list-settings-text"><?=htmlspecialcharsbx($item['PAGES_USE_DISPLAY'])?></span>
					</div>
				</div><!--intranet-button-list-deal-container-->
			</div><!--intranet-button-list-inner-info-container-->

			<div class="intranet-button-list-activate-wrapper">
				<div class="intranet-button-list-activate-container <?=($arResult['PERM_CAN_EDIT'] ? '' : 'intranet-button-list-activate-disabled')?> <?=($item['ACTIVE'] == 'Y' ? 'intranet-button-list-on' : 'intranet-button-list-off')?>"
					data-bx-crm-webform-item-active="">
					<div class="intranet-button-list-activate-button-container">
						<span class="intranet-button-list-activate-button">
							<span class="intranet-button-list-activate-button-text"><?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_ON')?></span>
						</span>
						<span class="intranet-button-list-not-activate-button">
							<span class="intranet-button-list-activate-button-cursor"></span>
							<span class="intranet-button-list-not-activate-button-text"><?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_OFF')?></span>
						</span>
					</div><!--intranet-button-list-activate-button-container-->
					<span class="intranet-button-list-activate-button-item-on"><?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_ON_STATUS')?></span>
					<span class="intranet-button-list-activate-button-item-off"><?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_OFF_STATUS')?></span>
				</div><!--intranet-button-list-activate-container-->
				<span class="intranet-button-list-activate-user-wrapper" data-bx-crm-webform-item-active-date="">
					<span class="intranet-button-list-activate-user-container user-container-on">
						<?
						if($item['ACTIVE_CHANGE_BY_DISPLAY']['ICON'])
						{
							$userIconStyle = 'background-image: url(\'' . htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_DISPLAY']['ICON']) .'\');';
							$userIconClass = '';
						}
						else
						{
							$userIconStyle = '';
							$userIconClass = 'user-default-icon';
						}
						?>
						<span class="intranet-button-list-activate-user-icon <?=$userIconClass?>" style="<?=$userIconStyle?>"></span>
						<span class="intranet-button-list-activate-user-inner">
							<a href="<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_DISPLAY']['LINK'])?>" class="intranet-button-list-activate-user-element">
								<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_DISPLAY']['NAME'])?>
							</a>
							<div class="intranet-button-list-activate-comments">
								<?if($item['ACTIVE_CHANGE_DATE_DISPLAY']):?>
									<?=($item['ACTIVE'] == 'Y' ? Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_ACTIVATED') : Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_DEACTIVATED'))?> <?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_ACT_ON')?>  <?=$item['ACTIVE_CHANGE_DATE_DISPLAY']?>
								<?endif;?>
							</div>
						</span>
					</span>
					<span class="intranet-button-list-activate-user-container user-container-off">
						<?
						if($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['ICON'])
						{
							$userIconStyle = 'background-image: url(\'' . htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['ICON']) .'\');';
							$userIconClass = '';
						}
						else
						{
							$userIconStyle = '';
							$userIconClass = 'user-default-icon';
						}
						?>
						<span class="intranet-button-list-activate-user-icon <?=$userIconClass?>" style="<?=$userIconStyle?>"></span>
						<span class="intranet-button-list-activate-user-inner">
							<a href="<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['LINK'])?>" class="intranet-button-list-activate-user-element">
								<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['NAME'])?>
							</a>
							<div class="intranet-button-list-activate-comments">
								<span class="intranet-button-list-activate-comments-act"><?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_ON_NOW')?></span>
								<span class="intranet-button-list-activate-comments-deact"><?=Loc::getMessage('CRM_BUTTON_LIST_ITEM_ACTIVE_OFF_NOW')?></span>
							</div>
						</span>
					</span>
				</span>
			</div>

		</div><!--intranet-button-list-widget-container intranet-button-list-widget-right-->
	</div><!--intranet-button-list-widget-row-->

<?endforeach;?>
<?endforeach;?>
</div><!--intranet-button-list-wrapper-->
</div>

<script>
	BX.ready(function(){
		(new CrmWebFormList(<?=Json::encode(
			array(
				'context' => 'crm_web_form_list_container',
				'canEdit' => $arResult['PERM_CAN_EDIT'],
				'viewUserOptionName' => $arResult['userOptionViewType'],
				'viewList' => $arResult['viewList'],
				'actionList' => $arResult['actionList'],
				'detailPageUrlTemplate' => $arParams['PATH_TO_BUTTON_EDIT'],
				'actionRequestUrl' => $this->getComponent()->getPath() . '/ajax.php',
				'mess' => array(
					'errorAction' => Loc::getMessage('CRM_BUTTON_LIST_ERROR_ACTION'),
					'deleteConfirmation' => Loc::getMessage('CRM_BUTTON_LIST_DELETE_CONFIRM'),
					'dlgBtnClose' => Loc::getMessage('CRM_BUTTON_LIST_CLOSE'),
					'dlgBtnApply' => Loc::getMessage('CRM_BUTTON_LIST_APPLY'),
					'dlgBtnCancel' => Loc::getMessage('CRM_BUTTON_LIST_CANCEL'),
					'dlgActiveCountLimitedTitle' => Loc::getMessage('CRM_BUTTON_LIST_POPUP_LIMITED_TITLE'),
					'dlgActiveCountLimitedText' => Loc::getMessage('CRM_BUTTON_LIST_POPUP_LIMITED_TEXT')
				)
			))?>
		));
	});
</script>