<?
define("STOP_STATISTICS", true);

require_once($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/prolog_before.php");

$arReturn = array();

if (!CModule::IncludeModule('crm'))
	$arReturn['ERROR'][] = GetMessage('CRM_PS_MODULE_NOT_INSTALLED');

if(!isset($arReturn['ERROR']))
{
	$CrmPerms = new CCrmPerms($USER->GetID());
	$bCrmWritePerm = $CrmPerms->HavePerm('CONFIG', BX_CRM_PERM_CONFIG, 'WRITE');

	if($USER->IsAuthorized() && check_bitrix_sessid() && $bCrmWritePerm)
	{
		$ID = isset($_REQUEST['id']) ? $_REQUEST['id'] : 0;
		$personTypeId = isset($_REQUEST['person_type']) ? $_REQUEST['person_type'] : 0;
		$action = isset($_REQUEST['action']) ? trim($_REQUEST['action']) : '';

		switch ($action)
		{
				case 'get_fields':

					$arReturn['FIELDS'] = CCrmPaySystem::getPSCorrespondence($ID);

					$path = \Bitrix\Sale\PaySystem\Manager::getPathToHandlerFolder($ID);
					if (\Bitrix\Main\IO\File::isFileExists(\Bitrix\Main\Application::getDocumentRoot().$path.'/.description.php'))
					{
						require \Bitrix\Main\Application::getDocumentRoot().$path.'/.description.php';
						if (isset($data))
							$arReturn["NAME"] = $data['NAME'];
						elseif (isset($psTitle))
							$arReturn["NAME"] = $psTitle;
					}

					foreach ($arReturn['FIELDS'] as $code => $data)
					{
						if ($data['TYPE'] == 'SELECT')
						{
							if (array_key_exists('VALUE', $data) && is_array($data['VALUE']))
							{
								foreach ($data['VALUE'] as $key => $option)
								{
									if (is_array($option) && array_key_exists('NAME', $option))
									{
										$arReturn['FIELDS'][$code]['VALUE'][$key] = $option['NAME'];
									}
								}
							}
						}

						$map = \Bitrix\Sale\BusinessValue::getMapping($code);
						if ($map === null)
							continue;

						if ($map['PROVIDER_VALUE'] != '' && $map['PROVIDER_KEY'] != '')
						{
							if (!in_array($data['TYPE'], array('SELECT', 'FILE', 'CHECKBOX')))
								$arReturn['FIELDS'][$code]['TYPE'] = $map['PROVIDER_KEY'];

							if ($data['TYPE'] != 'SELECT')
								$arReturn['FIELDS'][$code]['VALUE'] = $map['PROVIDER_VALUE'];
						}
					}

					CCrmPaySystem::rewritePSCorrByRqSource($personTypeId, $arReturn['FIELDS'], array('PSA_CODE' => $ID));

					$arReturn['FIELDS_BY_GROUP'] = array();
					foreach ($arReturn['FIELDS'] as $key => $value)
					{
						if (!array_key_exists($value['GROUP'], $arReturn['FIELDS_BY_GROUP']))
							$arReturn['FIELDS_BY_GROUP'][$value['GROUP']] = array();

						$arReturn['FIELDS_BY_GROUP'][$value['GROUP']][$key] = $value;
					}
					$arReturn['FIELDS_LIST'] =  implode(',', array_keys($arReturn['FIELDS']));

					$arReturn['GROUP_LIST'] = \Bitrix\Sale\BusinessValue::getGroups();

				break;
		}
	}
	else
	{
		$arReturn['ERROR'][] = GetMessage('CRM_PS_ACCESS_DENIED');
	}
}

$arReturn = $APPLICATION->ConvertCharsetArray($arReturn, SITE_CHARSET, 'utf-8');
echo json_encode($arReturn);

require_once($_SERVER["DOCUMENT_ROOT"].BX_ROOT."/modules/main/include/epilog_after.php");
?>