
BX.crmInvoicePaymentClient = (function()
{
	var classDescription = function(params)
	{
		this.nameValue = params.nameValue || "buyMoney";
		this.ajaxUrl = params.url + "?hash=" + params.hash;
		this.hash = params.hash || {};
		this.wrapperId = params.wrapperId || "";
		this.templateBill = params.templateBill || "";
		this.templateFolder = params.templateFolder;
		this.accountNumber = params.accountNumber;

		this.wrapper = document.getElementById('crm-invoice-payment-client-wrapper');
		this.templateBlock = this.wrapper.getElementsByClassName('crm-invoice-payment-client-template')[0];
		this.paySystemsContainer = this.wrapper.getElementsByClassName('crm-invoice-payment-system-array')[0];
		this.paySystemsTemplate = this.wrapper.getElementsByClassName('crm-invoice-payment-system-template')[0];
		this.switcher = this.wrapper.getElementsByClassName('crm-invoice-payment-system-return-list')[0];
		this.frame = document.getElementById('crm-invoice-payment-template-frame');

		var base = document.createElement('base');
		base.href = window.location.href;
		this.frame.contentDocument.open();
		this.frame.contentDocument.close();
		this.frame.contentDocument.head.appendChild(base);
		this.frame.contentDocument.body.innerHTML = this.templateBill;
		BX.ready(BX.proxy(this.init, this));
	};
	
	classDescription.prototype.init = function()
	{
		BX.bindDelegate(this.paySystemsContainer, 'click', { 'className': 'crm-invoice-payment-system-image' }, BX.proxy(
			function(event)
			{
				BX.ajax(
					{
						method: 'POST',
						dataType: 'html',
						url: this.ajaxUrl,
						data:
						{
							sessid: BX.bitrix_sessid(),
							paySystemId: event.target.getElementsByTagName('input')[0].value,
							accountNumber: this.accountNumber,
							hash: this.hash
						},
						onsuccess: BX.proxy(function(result)
						{
							this.paySystemsTemplate.innerHTML = result;
							this.paySystemsTemplate.style.display = 'block';
							this.switcher.style.display = 'block';
							this.paySystemsContainer.style.display = 'none';
						},this),
						onfailure: BX.proxy(function()
						{
							return this;
						}, this)
					}, this
				);

				return this;
			}, this)
		);

		window.parent.setTimeout(BX.delegate(function()
		{
			this.resizeForm();
		},this), 100);

		BX.bind(window,'load', BX.proxy(this.resizeForm, this));

		BX.bind(this.switcher,'click', BX.proxy(
			function()
			{
				this.paySystemsContainer.style.display = 'block';
				this.switcher.style.display = 'none';
				this.paySystemsTemplate.style.display = 'none';
				this.paySystemsTemplate.innerHTML = null;
			}, this)
		);
		
		return this;
	};

	classDescription.prototype.resizeForm = function()
	{
		this.frame.height = this.frame.contentDocument.documentElement.scrollHeight;
		this.frame.width = this.frame.contentDocument.documentElement.scrollWidth;
		this.frame.contentDocument.body.style.margin = 0;
		this.frame.contentDocument.body.style.padding = 0;
	};

	return classDescription;	  
})();
