<?if (!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true) die();

if (!CModule::IncludeModule('crm'))
{
	ShowError(GetMessage('CRM_MODULE_NOT_INSTALLED'));
	return;
}

global $USER, $APPLICATION;

$CrmPerms = new CCrmPerms($USER->GetID());
if (!$CrmPerms->HavePerm('CONFIG', BX_CRM_PERM_CONFIG, 'READ'))
{
	ShowError(GetMessage('CRM_PERMISSION_DENIED'));
	return;
}

$arParams['PATH_TO_PRODUCT_LIST'] = CrmCheckPath('PATH_TO_PRODUCT_LIST', $arParams['PATH_TO_PRODUCT_LIST'], '');
$arParams['PATH_TO_PRODUCT_FILE'] = CrmCheckPath(
	'PATH_TO_PRODUCT_FILE', $arParams['PATH_TO_PRODUCT_FILE'],
	$APPLICATION->GetCurPage().'?product_id=#product_id#&field_id=#field_id#&file_id=#file_id#&file'
);

//CUtil::InitJSCore(array('ajax', 'tooltip'));

$bVatMode = CCrmTax::isVatMode();

$vatRateListItems = array();
if ($bVatMode)
	$vatRateListItems = CCrmVat::GetVatRatesListItems();

// measure list items
$measureListItems = array('' => GetMessage('CRM_MEASURE_NOT_SELECTED'));
$measures = \Bitrix\Crm\Measure::getMeasures(100);
if (is_array($measures))
{
	foreach ($measures as $measure)
		$measureListItems[$measure['ID']] = $measure['SYMBOL'];
	unset($measure);
}
unset($measures);

$productID = isset($arParams['PRODUCT_ID']) ? intval($arParams['PRODUCT_ID']) : 0;
if($productID <= 0)
{
	$productIDParName = isset($arParams['PRODUCT_ID_PAR_NAME']) ? strval($arParams['PRODUCT_ID_PAR_NAME']) : '';
	if(strlen($productIDParName) == 0)
	{
		$productIDParName = 'product_id';
	}

	$productID = isset($_REQUEST[$productIDParName]) ? intval($_REQUEST[$productIDParName]) : 0;
}

$arResult['PRODUCT_ID'] = $productID;
$product = $productID > 0 ? CCrmProduct::GetByID($productID, true) : false;
$arResult['CATALOG_ID'] = $catalogID = isset($product['CATALOG_ID']) ?
	intval($product['CATALOG_ID']) :
	(isset($arParams['CATALOG_ID']) ? intval($arParams['CATALOG_ID']) : CCrmCatalog::EnsureDefaultExists());

if(!$product)
{
	ShowError(GetMessage('CRM_PRODUCT_NOT_FOUND'));
	@define('ERROR_404', 'Y');
	if($arParams['SET_STATUS_404'] === 'Y')
	{
		CHTTP::SetStatus("404 Not Found");
	}
	return;
}

// Product properties
$arPropUserTypeList = CCrmProductPropsHelper::GetPropsTypesByOperations(false, 'view');
$arResult['PROP_USER_TYPES'] = $arPropUserTypeList;
$arProps = CCrmProductPropsHelper::GetProps($catalogID, $arPropUserTypeList);
$arResult['PROPS'] = $arProps;

$arResult['PRODUCT'] = $product;

$arResult['FORM_ID'] = 'CRM_PRODUCT_SHOW';
$arResult['GRID_ID'] = 'CRM_PRODUCT_LIST';

// Product properties values
/*$arResult['PRODUCT_PROPS'] = array();*/
$arPropertyValues = array();
if ($productID > 0/* && count($arProps) > 0*/)
{
	$rsProperties = CIBlockElement::GetProperty(
		$catalogID,
		$productID,
		array(
			'sort' => 'asc',
			'id' => 'asc',
			'enum_sort' => 'asc',
			'value_id' => 'asc',
		),
		array(
			'ACTIVE' => 'Y',
			'EMPTY' => 'N',
			'CHECK_PERMISSIONS' => 'N'
		)
	);
	while ($arProperty = $rsProperties->Fetch())
	{
		if (isset($arProperty['USER_TYPE']) && !empty($arProperty['USER_TYPE'])
			&& !array_key_exists($arProperty['USER_TYPE'], $arPropUserTypeList))
			continue;

		$propID = 'PROPERTY_' . $arProperty['ID'];
		if(!isset($arPropertyValues[$propID]))
			$arPropertyValues[$propID] = array();

		if(isset($arProperty['USER_TYPE']) && !empty($arProperty['USER_TYPE'])
			&& is_array($arPropUserTypeList[$arProperty['USER_TYPE']])
			&& array_key_exists('GetPublicViewHTML', $arPropUserTypeList[$arProperty['USER_TYPE']]))
		{
			$arPropertyValues[$propID][] = call_user_func_array($arPropUserTypeList[$arProperty['USER_TYPE']]["GetPublicViewHTML"], array(
				$arProps[$propID],
				array("VALUE" => $arProperty["VALUE"]),
				array(),
			));
		}
		elseif($arProperty["PROPERTY_TYPE"] == "L")
		{
			$arPropertyValues[$propID][] = htmlspecialcharsex($arProperty["VALUE_ENUM"]);
		}
		else
		{
			$arPropertyValues[$propID][] = nl2br(htmlspecialcharsex($arProperty["VALUE"]));
		}
	}
	unset($rsProperties, $arProperty, $propID);
}
$arResult['PROPERTY_VALUES'] = $arPropertyValues;
unset($arPropertyValues);

$arResult['FIELDS'] = array();
$arResult['FIELDS']['tab_1'][] = array(
	'id' => 'product_info',
	'name' => GetMessage('CRM_SECTION_PRODUCT_INFO'),
	'type' => 'section',
	'isTactile' => true
);

$arResult['FIELDS']['tab_1'][] = array(
	'id' => 'ID',
	'name' => 'ID',
	'type' => 'label',
	'params' => array('size' => 50),
	'value' => $product['ID'],
	'isTactile' => true
);

$arResult['FIELDS']['tab_1'][] = array(
	'id' => 'NAME',
	'name' => GetMessage('CRM_PRODUCT_FIELD_NAME'),
	'params' => array('size' => 50),
	'type' => 'label',
	'value' => isset($product['~NAME']) ? $product['~NAME'] : '',
	'isTactile' => true
);

if(isset($product['~DESCRIPTION']) && strlen($product['~DESCRIPTION']) > 0)
{
	$arResult['FIELDS']['tab_1'][] = array(
		'id' => 'DESCRIPTION',
		'name' => GetMessage('CRM_FIELD_DESCRIPTION'),
		'params' => array('size' => 50),
		'type' => 'label',
		'value' => $product['~DESCRIPTION'],
		'isTactile' => true
	);
}

$arResult['FIELDS']['tab_1'][] = array(
	'id' => 'ACTIVE',
	'name' => GetMessage('CRM_FIELD_ACTIVE'),
	'type' => 'label',
	'params' => array(),
	'value' => GetMessage(isset($product['ACTIVE']) && $product['ACTIVE'] == 'Y' ? 'MAIN_YES' : 'MAIN_NO'),
	'isTactile' => true
);

$price = CCrmProduct::FormatPrice($product);
if(strlen($price) > 0)
{
	$arResult['FIELDS']['tab_1'][] = array(
		'id' => 'PRICE',
		'name' => GetMessage('CRM_FIELD_PRICE'),
		'type' => 'label',
		'params' => array(),
		'value' => $price,
		'isTactile' => true
	);
}

if ($bVatMode)
{
	$arResult['FIELDS']['tab_1'][] = array(
		'id' => 'VAT_ID',
		'name' => GetMessage('CRM_FIELD_VAT_ID'),
		'type' => 'label',
		'params' => array(),
		'value' => htmlspecialcharsbx((isset($product['VAT_ID']) && $product['VAT_ID'] > 0) ? $vatRateListItems[$product['VAT_ID']] : $vatRateListItems['']),
		'isTactile' => true
	);

	$arResult['FIELDS']['tab_1'][] = array(
		'id' => 'VAT_INCLUDED',
		'name' => GetMessage('CRM_FIELD_VAT_INCLUDED'),
		'type' => 'label',
		'params' => array(),
		'value' => GetMessage(isset($product['VAT_INCLUDED']) && $product['VAT_INCLUDED'] == 'Y' ? 'MAIN_YES' : 'MAIN_NO'),
		'isTactile' => true
	);
}

$arResult['FIELDS']['tab_1'][] = array(
	'id' => 'MEASURE',
	'name' => GetMessage('CRM_FIELD_MEASURE'),
	'type' => 'label',
	'params' => array(),
	'value' => htmlspecialcharsbx(isset($product['MEASURE']) ? $measureListItems[$product['MEASURE']] : $measureListItems['']),
	'isTactile' => true
);

$productSectionID = isset($product['SECTION_ID']) ? $product['SECTION_ID'] : 0;
$productSectionName = '';
if($productSectionID > 0)
{
	$sectionListItems = array();
	$rsSection = CIBlockSection::GetByID($productSectionID);
	if($arSection = $rsSection->Fetch())
	{
		$productSectionName = $arSection['NAME'];
	}
}

$arResult['FIELDS']['tab_1'][] = array(
	'id' => 'SECTION',
	'name' => GetMessage('CRM_FIELD_SECTION'),
	'type' => 'label',
	'value' => htmlspecialcharsbx(empty($productSectionName) ? GetMessage('CRM_SECTION_NOT_SELECTED') : $productSectionName),
	'isTactile' => true
);

$arResult['FIELDS']['tab_1'][] = array(
	'id' => 'SORT',
	'name' => GetMessage('CRM_FIELD_SORT'),
	'type' => 'label',
	'params' => array(),
	'value' => isset($product['SORT']) ? $product['SORT'] : '',
	'isTactile' => true
);

$arFields = array(
	'PREVIEW_PICTURE' => GetMessage('CRM_PRODUCT_FIELD_PREVIEW_PICTURE'),
	'DETAIL_PICTURE' => GetMessage('CRM_PRODUCT_FIELD_DETAIL_PICTURE')
);
$html = '';
$obFileControl = $obFile = null;
foreach ($arFields as $fieldID => $fieldName)
{
	if (isset($product['~'.$fieldID]))
	{
		$obFile = new CCrmProductFile(
			$arResult['PRODUCT_ID'],
			$fieldID,
			$product['~'.$fieldID]
		);

		$obFileControl = new CCrmProductFileControl($obFile, $fieldID);

		$html = '<nobr>'.$obFileControl->GetHTML(array(
				'show_input' => false,
				'max_size' => 102400,
				'max_width' => 150,
				'max_height' => 150,
				'url_template' => $arParams['PATH_TO_PRODUCT_FILE'],
				'a_title' => GetMessage('CRM_PRODUCT_PROP_ENLARGE'),
				'download_text' => GetMessage("CRM_PRODUCT_PROP_DOWNLOAD"),
			)).'</nobr>';

		$arResult['FIELDS']['tab_1'][] = array(
			'id' => $fieldID,
			'name' => $fieldName,
			'type' => 'custom',
			'value' => $html,
			'isTactile' => true
		);
	}
}
unset($arFields, $fieldID, $fieldName, $obFile, $obFileControl, $html);

/*if($FIELD_ID == "PREVIEW_PICTURE" || $FIELD_ID == "DETAIL_PICTURE")
{
	$obFile = new CListFile(
		$arResult["IBLOCK_ID"],
		0, //section_id
		$arRow["data"]["ID"],
		$FIELD_ID,
		$value
	);
	$obFile->SetSocnetGroup($arParams["SOCNET_GROUP_ID"]);

	$obFileControl = new CListFileControl($obFile, $FIELD_ID);

	$value = '<nobr>'.$obFileControl->GetHTML(array(
			'show_input' => false,
			'max_size' => 102400,
			'max_width' => 50,
			'max_height' => 50,
			'url_template' => $arParams["~LIST_FILE_URL"],
			'a_title' => GetMessage("CT_BLL_ENLARGE"),
			'download_text' => GetMessage("CT_BLL_DOWNLOAD"),
		)).'</nobr>';
}*/

$this->IncludeComponentTemplate();
include_once($_SERVER['DOCUMENT_ROOT'].'/bitrix/components/bitrix/crm.product/include/nav.php');
?>