<?php
use Bitrix\Main\Loader;
use Bitrix\Main\Context;
use Bitrix\Crm\WebForm\Form;
use Bitrix\Main\Localization\Loc;

define('STOP_STATISTICS', true);
define('BX_SECURITY_SHOW_MESSAGE', true);

require_once($_SERVER['DOCUMENT_ROOT'].'/bitrix/modules/main/include/prolog_before.php');

if (!Loader::includeModule('crm'))
{
	return;
}

Loc::loadMessages(__FILE__);

class CrmWebFormListAjaxController extends \Bitrix\Crm\WebForm\ComponentController
{
	protected function getActions()
	{
		return array(
			'activate',
			'deactivate',
			'delete',
			'copy',
			'reset_counters',
		);
	}

	protected function activate()
	{
		$form = new Form($this->requestData['FORM_ID']);
		if(!$form->isSystem() && !Form::canActivateForm())
		{
			$this->responseData['limited'] = true;
			$this->errors[] = '';
			return;
		}

		global $USER;
		if(!Form::activate($this->requestData['FORM_ID'], true, $USER->GetID()))
		{
			$this->errors[] = '';
		}
	}

	protected function deactivate()
	{
		global $USER;
		if(!Form::activate($this->requestData['FORM_ID'], false, $USER->GetID()))
		{
			$this->errors[] = '';
		}
	}

	protected function delete()
	{
		//sleep(3); $this->errors[] = ''; return;
		if(!Form::delete($this->requestData['FORM_ID']))
		{
			$this->errors[] = '';
		}
	}

	protected function reset_counters()
	{
		if(!Form::resetCounters($this->requestData['FORM_ID']))
		{
			$this->errors[] = '';
		}
	}

	protected function copy()
	{
		global $USER;
		$copiedId = Form::copy($this->requestData['FORM_ID'], $USER->GetID());
		if(!$copiedId)
		{
			$this->errors[] = '';
		}
		else
		{
			$this->responseData['copiedId'] = $copiedId;
		}
	}

	protected function checkPermissions()
	{
		/**@var $USER \CUSER*/
		global $USER;
		$CrmPerms = new CCrmPerms($USER->GetID());
		return !$CrmPerms->HavePerm('WEBFORM', BX_CRM_PERM_NONE, 'WRITE');
	}

	protected function prepareRequestData()
	{
		$this->requestData = array(
			'FORM_ID' => intval($this->request->get('form_id'))
		);
	}
}

$controller = new CrmWebFormListAjaxController();
$controller->exec();