<?php
if (!defined('B_PROLOG_INCLUDED') || B_PROLOG_INCLUDED!==true)die();

use Bitrix\Main\Web\Json;
use Bitrix\Main\Localization\Loc;

/** @var CBitrixComponentTemplate $this */
/** @var array $arParams */
/** @var array $arResult */

CJSCore::Init(array('clipboard'));
if(\Bitrix\Main\Loader::includeModule("bitrix24"))
{
	CBitrix24::initLicenseInfoPopupJS();
}
?>

<div class="crm-webform-list-wrapper">
	<p><?=Loc::getMessage('CRM_WEBFORM_LIST_DESC1')?></p>
	<p><?=Loc::getMessage('CRM_WEBFORM_LIST_DESC2')?></p>

	<?if($arResult['PERM_CAN_EDIT']):?>
	<a href="<?=htmlspecialcharsbx($arResult['PATH_TO_WEB_FORM_NEW'])?>">
	<div class="crm-webform-list-createform-container">
		<div class="crm-webform-list-createform-element"><?=Loc::getMessage('CRM_WEBFORM_LIST_ADD_CAPTION')?></div>
		<span class="crm-webform-list-createform-description"><?=Loc::getMessage('CRM_WEBFORM_LIST_ADD_DESC1')?></span>
	</div>
	</a>
	<?endif;?>

	<div id="crm_web_form_list_container">
	<!--crm-webform-list-createform-container-->
<?foreach($arResult['ITEMS_BY_IS_SYSTEM'] as $isSystem => $system):?>
	<div class="crm-webform-list-header-container">
		<h3 class="crm-webform-list-header"><?=htmlspecialcharsbx($system['NAME'])?></h3>
	</div><!--crm-webform-list-header-container-->

<?foreach($system['ITEMS'] as $item):?>
	<div class="crm-webform-list-widget-row"
		data-bx-crm-webform-item="<?=intval($item['ID'])?>"
	    data-bx-crm-webform-item-is-system="<?=$isSystem?>"
	>
		<div class="crm-webform-list-buttons-container">
			<div class="crm-webform-list-buttons">
				<span class="crm-webform-list-hamburger" data-bx-crm-webform-item-settings=""></span>
				<?if($arResult['PERM_CAN_EDIT'] && $item['IS_SYSTEM'] != 'Y'):?>
					<span class="crm-webform-list-close" data-bx-crm-webform-item-delete="" title="<?=Loc::getMessage('CRM_WEBFORM_LIST_ACTIONS_REMOVE')?>"></span>
				<?endif;?>
			</div><!--crm-webform-list-buttons-->
		</div><!--crm-webform-list-button-container-->
		<div class="crm-webform-list-widget-container crm-webform-list-widget-left">
			<div class="crm-webform-list-widget crm-webform-list-widget-number <?=$item['viewClassName']?>" data-bx-crm-webform-item-view="">
				<div class="crm-webform-list-widget-head">
					<span class="crm-widget-settings" data-bx-crm-webform-item-view-settings=""></span>
					<span class="crm-webform-list-widget-title-container">
						<span class="crm-webform-list-widget-title-inner">
							<a href="<?=htmlspecialcharsbx($item['PATH_TO_WEB_FORM_EDIT'])?>">
							<span class="crm-webform-list-widget-title"><?=htmlspecialcharsbx($item['NAME'])?></span>
							</a>
						</span>
					</span>
				</div><!--crm-webform-list-widget-head-->
				<div class="crm-webform-list-widget-content">
					<div class="crm-webform-list-widget-content-amt">
						<span class="crm-webform-list-widget-content-image"></span>
						<div style="position: relative;left: 118px;">
							<?foreach($item['itemViewList'] as $viewType => $view):?>
							<div class="crm-webform-list-widget-content-item <?=($view['SELECTED'] ? 'crm-webform-list-widget-content-item-show' : '')?>" data-bx-crm-webform-view-info="<?=$viewType?>">
								<div class="crm-crm-webform-list-widget-content-title"><?=$view['TEXT']?></div>
								<div class="crm-webform-list-widget-content-number">
									<?=$item['SUMMARY_' . $viewType . '_DISPLAY']?>
								</div>
							</div>
							<?endforeach;?>
						</div>
						<div class="crm-webform-list-widget-content-attempt" style="top: 67px; position: relative;">
							<span class="crm-webform-list-widget-content-attempt-total">
								<span class="crm-webform-list-widget-content-attempt-total-element"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_FILL_START')?></span>
								<div class="crm-webform-list-widget-content-attempt-total-number">
									<?=intval($item['COUNT_START_FILL'])?>
								</div>
							</span>
							<span class="crm-webform-list-widget-content-attempt-success">
								<span class="crm-webform-list-widget-content-attempt-success-element"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_FILL_END')?></span>
								<div class="crm-webform-list-widget-content-attempt-success-number">
									<?=intval($item['COUNT_END_FILL'])?>
								</div>
							</span>
						</div>
					</div>
				</div><!--crm-webform-list-widget-content-->
			</div><!--crm-webform-list-widget crm-webform-list-widget-number-->
		</div><!--crm-webform-list-widget-container crm-webform-list-widget-left-->
		<div class="crm-webform-list-widget-container crm-webform-list-widget-right">

			<div class="crm-webform-list-inner-info-container">
				<div class="crm-webform-list-creation-date-container">
					<div class="crm-webform-list-creation-date-element">
						<span class="crm-webform-list-text"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_DATE_CREATE')?>:</span>
						<span class="crm-webform-list-date"><?=htmlspecialcharsbx($item['DATE_CREATE_DISPLAY'])?></span>
					</div>
				</div><!--crm-webform-list-creation-date-container-->
				<div class="crm-webform-list-url-container">
					<div class="crm-webform-list-url-element">
						<span class="crm-webform-list-url-inner-wrap">
							<span class="crm-webform-list-url-text"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_PUBLIC_LINK')?>:</span>
							<a href="<?=htmlspecialcharsbx($item['PATH_TO_WEB_FORM_FILL'])?>" target="_blank" class="copy-to-clipboard-node crm-webform-list-url-link">
								<?=htmlspecialcharsbx($item['PATH_TO_WEB_FORM_FILL'])?>
							</a>
						</span>
						<span class="copy-to-clipboard-button crm-webform-list-url-link-icon" title="<?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_PUBLIC_LINK_COPY')?>"></span>
					</div>
				</div><!--crm-webform-list-url-container-->
				<div class="crm-webform-list-deal-container">
					<div class="crm-webform-list-deal-element">
						<span class="crm-webform-deal-text"><?=htmlspecialcharsbx($item['ENTITY_COUNTERS_DISPLAY'])?></span>
					</div>
				</div><!--crm-webform-list-deal-container-->
				<div class="crm-webform-list-fill-started-container">
					<div class="crm-webform-list-fill-started-element">
						<span class="crm-webform-fill-started-text">
							<?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_START_EDIT_BUT_STOPPED')?> - <?=intval($item['COUNT_QUIT_FILL'])?>
						</span>
					</div>
				</div><!--crm-webform-list-fill-started-container-->
			</div><!--crm-webform-list-inner-info-container-->

			<div class="crm-webform-list-activate-wrapper">
				<div class="crm-webform-list-activate-container <?=($arResult['PERM_CAN_EDIT'] ? '' : 'crm-webform-list-activate-disabled')?> <?=($item['ACTIVE'] == 'Y' ? 'crm-webform-list-on' : 'crm-webform-list-off')?>"
					data-bx-crm-webform-item-active=""
				>
					<div class="crm-webform-list-activate-button-container">
						<span class="crm-webform-list-activate-button">
							<span class="crm-webform-list-activate-button-text"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_ON')?></span>
						</span>
						<span class="crm-webform-list-not-activate-button">
							<span class="crm-webform-list-activate-button-cursor"></span>
							<span class="crm-webform-list-not-activate-button-text"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_OFF')?></span>
						</span>
					</div><!--crm-webform-list-activate-button-container-->
					<span class="crm-webform-list-activate-button-item-on"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_ON_STATUS')?></span>
					<span class="crm-webform-list-activate-button-item-off"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_OFF_STATUS')?></span>
				</div><!--crm-webform-list-activate-container-->
				<span class="crm-webform-list-activate-user-wrapper" data-bx-crm-webform-item-active-date="">
					<span class="crm-webform-list-activate-user-container user-container-on">
						<?
						if($item['ACTIVE_CHANGE_BY_DISPLAY']['ICON'])
						{
							$userIconStyle = 'background-image: url(\'' . htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_DISPLAY']['ICON']) .'\');';
							$userIconClass = '';
						}
						else
						{
							$userIconStyle = '';
							$userIconClass = 'user-default-icon';
						}
						?>
						<span class="crm-webform-list-activate-user-icon <?=$userIconClass?>" style="<?=$userIconStyle?>"></span>
						<span class="crm-webform-list-activate-user-inner">
							<a href="<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_DISPLAY']['LINK'])?>" class="crm-webform-list-activate-user-element">
								<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_DISPLAY']['NAME'])?>
							</a>
							<div class="crm-webform-list-activate-comments">
								<?if($item['ACTIVE_CHANGE_DATE_DISPLAY']):?>
									<?=($item['ACTIVE'] == 'Y' ? Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_ACTIVATED') : Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_DEACTIVATED'))?> <?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_ACT_ON')?>  <?=$item['ACTIVE_CHANGE_DATE_DISPLAY']?>
								<?endif;?>
							</div>
						</span>
					</span>
					<span class="crm-webform-list-activate-user-container user-container-off">
						<?
						if($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['ICON'])
						{
							$userIconStyle = 'background-image: url(\'' . htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['ICON']) .'\');';
							$userIconClass = '';
						}
						else
						{
							$userIconStyle = '';
							$userIconClass = 'user-default-icon';
						}
						?>
						<span class="crm-webform-list-activate-user-icon <?=$userIconClass?>" style="<?=$userIconStyle?>"></span>
						<span class="crm-webform-list-activate-user-inner">
							<a href="<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['LINK'])?>" class="crm-webform-list-activate-user-element">
								<?=htmlspecialcharsbx($item['ACTIVE_CHANGE_BY_NOW_DISPLAY']['NAME'])?>
							</a>
							<div class="crm-webform-list-activate-comments">
								<span class="crm-webform-list-activate-comments-act"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_ON_NOW')?></span>
								<span class="crm-webform-list-activate-comments-deact"><?=Loc::getMessage('CRM_WEBFORM_LIST_ITEM_ACTIVE_OFF_NOW')?></span>
							</div>
						</span>
					</span>
				</span>
			</div>

		</div><!--crm-webform-list-widget-container crm-webform-list-widget-right-->
	</div><!--crm-webform-list-widget-row-->

<?endforeach;?>
<?endforeach;?>
</div><!--crm-webform-list-wrapper-->
</div>

<script>
	BX.ready(function(){
		(new CrmWebFormList(<?=Json::encode(
			array(
				'context' => 'crm_web_form_list_container',
				'canEdit' => $arResult['PERM_CAN_EDIT'],
				'viewUserOptionName' => $arResult['userOptionViewType'],
				'viewList' => $arResult['viewList'],
				'actionList' => $arResult['actionList'],
				'detailPageUrlTemplate' => $arParams['PATH_TO_WEB_FORM_EDIT'],
				'actionRequestUrl' => $this->getComponent()->getPath() . '/ajax.php',
				'mess' => array(
					'errorAction' => Loc::getMessage('CRM_WEBFORM_LIST_ERROR_ACTION'),
					'deleteConfirmation' => Loc::getMessage('CRM_WEBFORM_LIST_DELETE_CONFIRM'),
					'dlgBtnClose' => Loc::getMessage('CRM_WEBFORM_LIST_CLOSE'),
					'dlgBtnApply' => Loc::getMessage('CRM_WEBFORM_LIST_APPLY'),
					'dlgBtnCancel' => Loc::getMessage('CRM_WEBFORM_LIST_CANCEL'),
					'dlgActiveCountLimitedTitle' => Loc::getMessage('CRM_WEBFORM_LIST_POPUP_LIMITED_TITLE'),
					'dlgActiveCountLimitedText' => Loc::getMessage('CRM_WEBFORM_LIST_POPUP_LIMITED_TEXT')
				)
			))?>
		));
	});
</script>