var CrmWebFormEditScript = function(params)
{
	this.init = function (params)
	{
		this.context = BX('CRM_WEBFORM_EDIT_SCRIPT');
		this.initTabs(params);
		this.initCopy(params);
	};

	this.initTabs = function (params)
	{
		this.tabAttribute = 'data-bx-webform-script-tab-cont';
		this.buttonTabAttribute = 'data-bx-webform-script-tab-btn';

		this.tabNodeList = this.context.querySelectorAll('[' + this.tabAttribute + ']');
		this.tabNodeList = BX.convert.nodeListToArray(this.tabNodeList);

		this.tabBtnNodeList = this.context.querySelectorAll('[' + this.buttonTabAttribute + ']');
		this.tabBtnNodeList = BX.convert.nodeListToArray(this.tabBtnNodeList);
		this.tabBtnNodeList.forEach(this.bindTabButtonClick, this);
	};

	this.bindTabButtonClick = function (tabBtnNode)
	{
		var _this = this;
		BX.bind(tabBtnNode, 'click', function(){
			var id = this.getAttribute(_this.buttonTabAttribute);
			_this.showTab(id);
		});
	};

	this.showTab = function (id)
	{
		this.tabBtnNodeList.forEach(function(tabBtnNode){
			var iteratedId = tabBtnNode.getAttribute(this.buttonTabAttribute);
			if(id == iteratedId)
			{
				BX.addClass(tabBtnNode, 'rule-tab-active');
			}
			else
			{
				BX.removeClass(tabBtnNode, 'rule-tab-active');
			}
		}, this);

		this.tabNodeList.forEach(function(tabNode){
			var iteratedId = tabNode.getAttribute(this.tabAttribute);
			tabNode.style.display = (id == iteratedId ? 'block' : 'none');
		}, this);
	};

	this.initCopy = function (params)
	{
		var buttonAttribute = 'data-bx-webform-script-copy-btn';
		var copyButtonList = this.context.querySelectorAll('[' + buttonAttribute + ']');
		copyButtonList = BX.convert.nodeListToArray(copyButtonList);
		copyButtonList.forEach(function(buttonNode){
			var id = buttonNode.getAttribute(buttonAttribute);
			var copyButtonText = this.context.querySelector('[data-bx-webform-script-copy-text="' + id + '"]');
			if(!copyButtonText)
			{
				return;
			}

			BX.clipboard.bindCopyClick(buttonNode, {text: copyButtonText, offsetLeft: 30});
		}, this);
	};

	this.init(params);
};

BX.ready(function(){
	(new CrmWebFormEditScript());
});
