CREATE TABLE B_CATALOG_CURRENCY
(
	CURRENCY char(3) NOT NULL,
	AMOUNT_CNT int NOT NULL,
	AMOUNT decimal(18, 4) NULL,
	SORT int NOT NULL,
	DATE_UPDATE datetime NOT NULL,
	NUMCODE char(3) NULL,
	BASE char(1) NOT NULL,
	CREATED_BY int NULL,
	DATE_CREATE datetime NULL,
	MODIFIED_BY int NULL,
	CURRENT_BASE_RATE decimal(26, 12) NULL
)
GO
ALTER TABLE B_CATALOG_CURRENCY ADD CONSTRAINT PK_B_CATALOG_CURRENCY PRIMARY KEY (CURRENCY)
GO
ALTER TABLE B_CATALOG_CURRENCY ADD CONSTRAINT DF_B_CATALOG_CURRENCY_AMOUNT_CNT DEFAULT '1' FOR AMOUNT_CNT
GO
ALTER TABLE B_CATALOG_CURRENCY ADD CONSTRAINT DF_B_CATALOG_CURRENCY_SORT DEFAULT '100' FOR SORT
GO
ALTER TABLE B_CATALOG_CURRENCY ADD CONSTRAINT DF_B_CATALOG_CURRENCY_BASE DEFAULT 'N' FOR BASE
GO

CREATE TABLE B_CATALOG_CURRENCY_LANG
(
	CURRENCY char(3) NOT NULL,
	LID char(2) NOT NULL,
	FORMAT_STRING varchar(50) NOT NULL,
	FULL_NAME varchar(50) NULL,
	DEC_POINT varchar(5) NULL,
	THOUSANDS_SEP varchar(5) NULL,
	DECIMALS tinyint NOT NULL,
	THOUSANDS_VARIANT CHAR(1) NULL,
	HIDE_ZERO CHAR(1) NOT NULL,
	CREATED_BY int NULL,
	DATE_CREATE datetime NULL,
	MODIFIED_BY int NULL,
	TIMESTAMP_X datetime NULL
)
GO
ALTER TABLE B_CATALOG_CURRENCY_LANG ADD CONSTRAINT PK_B_CATALOG_CURRENCY_LANG PRIMARY KEY (CURRENCY, LID)
GO
ALTER TABLE B_CATALOG_CURRENCY_LANG ADD CONSTRAINT DF_B_CATALOG_CURRENCY_LANG_DEC_POINT DEFAULT '.' FOR DEC_POINT
GO
ALTER TABLE B_CATALOG_CURRENCY_LANG ADD CONSTRAINT DF_B_CATALOG_CURRENCY_LANG_THOUSANDS_SEP DEFAULT ' ' FOR THOUSANDS_SEP
GO
ALTER TABLE B_CATALOG_CURRENCY_LANG ADD CONSTRAINT DF_B_CATALOG_CURRENCY_LANG_DECIMALS DEFAULT '2' FOR DECIMALS
GO
ALTER TABLE B_CATALOG_CURRENCY_LANG ADD CONSTRAINT DF_B_CATALOG_CURRENCY_LANG_HIDE_ZERO DEFAULT 'N' FOR HIDE_ZERO
GO

CREATE TABLE B_CATALOG_CURRENCY_RATE
(
	ID int NOT NULL IDENTITY (1, 1),
	CURRENCY char(3) NOT NULL,
	BASE_CURRENCY char(3) NULL,
	DATE_RATE datetime NOT NULL,
	RATE_CNT int NOT NULL,
	RATE decimal(18, 4) NOT NULL,
	CREATED_BY int NULL,
	DATE_CREATE datetime NULL,
	MODIFIED_BY int NULL,
	TIMESTAMP_X datetime NULL
)
GO
ALTER TABLE B_CATALOG_CURRENCY_RATE ADD CONSTRAINT PK_B_CATALOG_CURRENCY_RATE PRIMARY KEY (ID)
GO
CREATE INDEX UX_B_CATALOG_CURRENCY_RATE_1 ON B_CATALOG_CURRENCY_RATE (CURRENCY, DATE_RATE)
GO
ALTER TABLE B_CATALOG_CURRENCY_RATE ADD CONSTRAINT DF_B_CATALOG_CURRENCY_RATE_RATE_CNT DEFAULT '1' FOR RATE_CNT
GO
ALTER TABLE B_CATALOG_CURRENCY_RATE ADD CONSTRAINT DF_B_CATALOG_CURRENCY_RATE_RATE DEFAULT '0.00' FOR RATE
GO