CREATE TABLE B_CATALOG_CURRENCY
(
	CURRENCY CHAR(3 CHAR) NOT NULL,
	AMOUNT_CNT NUMBER(18) DEFAULT '1' NULL,
	AMOUNT NUMBER(18, 4) NULL,
	SORT NUMBER(18) DEFAULT '100' NOT NULL,
	DATE_UPDATE DATE NOT NULL,
	NUMCODE CHAR(3 CHAR) NULL,
	BASE CHAR(1 CHAR) DEFAULT 'N' NOT NULL,
	CREATED_BY NUMBER(18) NULL,
	DATE_CREATE DATE NULL,
	MODIFIED_BY NUMBER(18) NULL,
	CURRENT_BASE_RATE NUMBER(26, 12) NULL,
	PRIMARY KEY (CURRENCY)
)
/

CREATE TABLE B_CATALOG_CURRENCY_LANG
(
	CURRENCY CHAR(3 CHAR) NOT NULL,
	LID CHAR(2 CHAR) NOT NULL,
	FORMAT_STRING VARCHAR2(50 CHAR) NOT NULL,
	FULL_NAME VARCHAR2(50 CHAR) NULL,
	DEC_POINT VARCHAR2(5 CHAR) DEFAULT '.' NULL,
	THOUSANDS_SEP VARCHAR2(5 CHAR) DEFAULT '' NULL,
	DECIMALS NUMBER(4) DEFAULT '2' NOT NULL,
	THOUSANDS_VARIANT CHAR(1 CHAR) NULL,
	HIDE_ZERO CHAR(1 CHAR) DEFAULT 'N' NOT NULL,
	CREATED_BY NUMBER(18) NULL,
	DATE_CREATE DATE NULL,
	MODIFIED_BY NUMBER(18) NULL,
	TIMESTAMP_X DATE NULL,
	PRIMARY KEY (CURRENCY, LID)
)
/

CREATE TABLE B_CATALOG_CURRENCY_RATE
(
	ID NUMBER(18) NOT NULL,
	CURRENCY CHAR(3 CHAR) NOT NULL,
	BASE_CURRENCY CHAR(3 CHAR) NULL,
	DATE_RATE DATE NOT NULL,
	RATE_CNT NUMBER(18) DEFAULT '1' NOT NULL,
	RATE NUMBER(18, 4) DEFAULT '0.00' NOT NULL,
	CREATED_BY NUMBER(18) NULL,
	DATE_CREATE DATE NULL,
	MODIFIED_BY NUMBER(18) NULL,
	TIMESTAMP_X DATE NULL,
	PRIMARY KEY (ID)
)
/
CREATE INDEX IX_CURRENCY_RATE ON B_CATALOG_CURRENCY_RATE(CURRENCY, DATE_RATE)
/
CREATE SEQUENCE SQ_B_CATALOG_CURRENCY_RATE INCREMENT BY 1 NOMAXVALUE NOCYCLE NOCACHE NOORDER
/
CREATE OR REPLACE TRIGGER B_CATALOG_CURRENCY_RATE_INSERT
BEFORE INSERT
ON B_CATALOG_CURRENCY_RATE
FOR EACH ROW
BEGIN
	IF :NEW.ID IS NULL THEN
 		SELECT SQ_B_CATALOG_CURRENCY_RATE.NEXTVAL INTO :NEW.ID FROM dual;
	END IF;
END;
/