CREATE TABLE B_DAV_LOCKS (
	ID varchar(128) NOT NULL,
	PATH varchar(255) NOT NULL,
	EXPIRES int NOT NULL,
	LOCK_OWNER varchar(255) NULL,
	LOCK_DEPTH char(1) NOT NULL DEFAULT 'N',
	LOCK_TYPE char(1) NOT NULL DEFAULT 'R',
	LOCK_SCOPE char(1) NOT NULL DEFAULT 'S',
	CREATED datetime NOT NULL,
	MODIFIED datetime NOT NULL
)
GO
ALTER TABLE B_DAV_LOCKS ADD CONSTRAINT PK_B_DAV_LOCKS PRIMARY KEY (ID)
GO
CREATE INDEX IX_B_DAV_LOCKS_P ON B_DAV_LOCKS(PATH)
GO
CREATE INDEX IX_B_DAV_LOCKS_E ON B_DAV_LOCKS(EXPIRES)
GO

CREATE TABLE B_DAV_CONNECTIONS (
	ID int NOT NULL IDENTITY (1, 1),
	ENTITY_TYPE varchar(32) NOT NULL DEFAULT 'user',
	ENTITY_ID int NOT NULL,
	ACCOUNT_TYPE varchar(32) NOT NULL,
	NAME varchar(128) NOT NULL,
	SERVER_SCHEME varchar(5) NOT NULL DEFAULT 'http',
	SERVER_HOST varchar(128) NOT NULL,
	SERVER_PORT int NOT NULL DEFAULT 80,
	SERVER_USERNAME varchar(128) NULL,
	SERVER_PASSWORD varchar(128) NULL,
	SERVER_PATH varchar(255) NOT NULL DEFAULT '/',
	CREATED datetime NOT NULL,
	MODIFIED datetime NOT NULL,
	SYNCHRONIZED datetime NULL,
	LAST_RESULT varchar(128) NULL
)
GO
ALTER TABLE B_DAV_CONNECTIONS ADD CONSTRAINT PK_B_DAV_CONNECTIONS PRIMARY KEY (ID)
GO
CREATE INDEX IX_B_DAV_CONNECTIONS_AT ON B_DAV_CONNECTIONS(ACCOUNT_TYPE)
GO
CREATE INDEX IX_B_DAV_CONNECTIONS_ENT ON B_DAV_CONNECTIONS(ENTITY_TYPE, ENTITY_ID, ACCOUNT_TYPE)
GO
