CREATE TABLE B_DAV_LOCKS (
	ID varchar2(128 CHAR) NOT NULL,
	PATH varchar2(255 CHAR) NOT NULL,
	EXPIRES int NOT NULL,
	LOCK_OWNER varchar2(255 CHAR) NULL,
	LOCK_DEPTH char(1 CHAR) DEFAULT 'N' NOT NULL,
	LOCK_TYPE char(1 CHAR) DEFAULT 'R' NOT NULL,
	LOCK_SCOPE char(1 CHAR) DEFAULT 'S' NOT NULL,
	CREATED date NOT NULL,
	MODIFIED date NOT NULL,
	primary key (ID)
)
/
CREATE INDEX IX_B_DAV_LOCKS_P ON B_DAV_LOCKS(PATH)
/
CREATE INDEX IX_B_DAV_LOCKS_E ON B_DAV_LOCKS(EXPIRES)
/

CREATE TABLE B_DAV_CONNECTIONS (
	ID int NOT NULL,
	ENTITY_TYPE varchar2(32 CHAR) DEFAULT 'user' NOT NULL,
	ENTITY_ID int NOT NULL,
	ACCOUNT_TYPE varchar2(32 CHAR) NOT NULL,
	NAME varchar2(128 CHAR) NOT NULL,
	SERVER_SCHEME varchar2(5 CHAR) DEFAULT 'http' NOT NULL,
	SERVER_HOST varchar2(128 CHAR) NOT NULL,
	SERVER_PORT int DEFAULT 80 NOT NULL,
	SERVER_USERNAME varchar2(128 CHAR) NULL,
	SERVER_PASSWORD varchar2(128 CHAR) NULL,
	SERVER_PATH varchar2(255 CHAR) DEFAULT '/' NOT NULL,
	CREATED date NOT NULL,
	MODIFIED date NOT NULL,
	SYNCHRONIZED date NULL,
	LAST_RESULT varchar2(128 CHAR) NULL,
	primary key (ID)
)
/
CREATE SEQUENCE SQ_B_DAV_CONNECTIONS INCREMENT BY 1 NOMAXVALUE NOCYCLE NOCACHE NOORDER
/
CREATE INDEX IX_B_DAV_CONNS_AT ON B_DAV_CONNECTIONS(ACCOUNT_TYPE)
/
CREATE INDEX IX_B_DAV_CONNS_ENT ON B_DAV_CONNECTIONS(ENTITY_TYPE, ENTITY_ID, ACCOUNT_TYPE)
/

