BX.namespace("BX.Mobile.Crm.Lead.Edit");

BX.Mobile.Crm.Lead.Edit = {
	ajaxPath: "",
	formActionUrl: "",
	formId: "",
	leadViewPath: "",
	mode: "",
	products: [],
	productDataFieldName: "",
	productsContainerNode: "",

	init: function(params)
	{
		if (params && typeof params === "object")
		{
			this.ajaxPath = params.ajaxPath || "";
			this.formActionUrl = params.formActionUrl || "";
			this.formId = params.formId || "";
			this.leadViewPath = params.leadViewPath || "";
			this.mode = params.mode || "";
			this.products = params.products || [];
			this.productDataFieldName = params.productDataFieldName || "";
			this.productsContainerNode = document.querySelector("[data-role='mobile-crm-lead-edit-products']") || "";
		}

		if (this.mode == "EDIT")
		{
			BX.addCustomEvent("onCrmLeadEditUpdate", BX.proxy(function(data){
				if (data.formId == this.formId)
				{
					BXMobileApp.UI.Page.reload();
				}
			}, this));
		}

		if (this.mode == "VIEW")
		{
			BX.addCustomEvent("onCrmLeadViewUpdate", BX.proxy(function(data){
				if (data.formId == this.formId)
				{
					BXMobileApp.UI.Page.reload();
				}
			}, this));

			//to refresh edit page after editing view page
			BX.addCustomEvent("onSubmitAjaxSuccess", BX.proxy(function (data) {
				if (data.formId == this.formId)
					app.onCustomEvent("onCrmLeadEditUpdate", {formId: this.formId});
			}, this));
		}

		BX.addCustomEvent("onCrmLeadDetailDelete", function(){
			app.onCustomEvent("onCrmLeadListUpdate", {});
			BXMobileApp.UI.Page.close({drop:true});
		});

		/*if (this.mode == "CREATE") // close create page after saving
		{
			var onLeadFormCloseHandler = function()
			{
				BX.removeCustomEvent("onOpenPageAfter", onLeadFormCloseHandler);
				app.closeModalDialog();
			};

			BX.addCustomEvent("onCrmLeadClosePage", function () {
				if (!(window.isCurrentPage && window.isCurrentPage == "Y"))
				{
					BX.addCustomEvent("onOpenPageAfter", onLeadFormCloseHandler);
				}
				else
				{
					window.isCurrentPage = "";
				}
			});
		}*/

		if (this.mode == "VIEW")
		{
			BX.addCustomEvent("onSubmitForm", BX.proxy(function(data, formNode, inputNode) {
				if (data.formId == this.formId)
				{
					//onChange checkboxes from the view mode
					if (inputNode.checked == false || !inputNode.hasAttribute("checked"))
					{
						var newInputNode = BX.create("INPUT", {
							attrs: {
								type: "hidden",
								name: inputNode.name,
								value: ""
							}
						});
						inputNode.parentNode.insertBefore(newInputNode, inputNode);
					}

					app.onCustomEvent("onCrmLeadListUpdate", {}); // update list after editing on view page
				}
			}, this));
		}
	},

	submit: function()
	{
		BXMobileApp.UI.Page.LoadingScreen.show();

		var form = BX(this.formId);
		if(form)
		{
			var dataFormValues = {save: "Y", sessid: BX.bitrix_sessid()};

			if (BX.Mobile.Crm.ProductEditor && BX.Mobile.Crm.ProductEditor.products)
			{
				dataFormValues[this.productDataFieldName] = BX.Mobile.Crm.ProductEditor.products;
			}

			BX.Mobile.Crm.Detail.collectInterfaceFormData(form, dataFormValues);

			BX.ajax({
				method: 'POST',
				dataType: 'json',
				url: this.formActionUrl,
				data: dataFormValues,
				onsuccess: BX.proxy(function(json)
				{
					if (json.error)
					{
						app.alert({text: json.error});
					}
					else
					{
						if (this.mode == "EDIT")
						{
							app.onCustomEvent("onCrmLeadListUpdate", {});
							app.onCustomEvent("onCrmLeadViewUpdate", {formId: this.formId});
							app.closeModalDialog({cache: false});
						}

						if (this.mode == "CREATE")
						{
							var viewPath = this.leadViewPath.replace("#lead_id#", json.itemId);
							app.onCustomEvent("onCrmLeadLoadPageBlank", {path: viewPath});
							app.closeModalDialog({cache: false});
						}
					}

					BXMobileApp.UI.Page.LoadingScreen.hide();
				}, this)
			});
		}
	}
};