(function (window)
{
	if (window.BX.MobileTools) return;


	BX.MobileTools = {
		phoneTo: function (number, params)
		{
			params = typeof(params) == 'object'? params: {};
			app.onCustomEvent("onPhoneTo", {number: number, params: params});
		},
		callTo: function (userId, video)
		{
			video = typeof(video) == 'undefined'? false: video;
			app.onCustomEvent("onCallInvite", {userId: userId, video: video});
		},
		getMobileUrlParams: function(url)
		{
			var mobileRegReplace = [
				{
					exp: /\/company\/personal\/user\/(\d+)\/calendar\/\?EVENT_ID=(\d+).*/gi,
					replace: "/mobile/calendar/view_event.php?event_id=$2",
					useNewStyle: false
				},
				{
					exp: /\/company\/personal\/user\/(\d+)\/tasks\/task\/view\/(\d+)\//gi,
					replace: "/mobile/tasks/snmrouter/?routePage=view&USER_ID=$1&GROUP_ID=0&TASK_ID=$2",
					useNewStyle: true
				},
				{
					exp: /\/company\/personal\/user\/(\d+)\/blog\/(\d+)\//gi,
					replace: "/mobile/log/?ACTION=CONVERT&ENTITY_TYPE_ID=BLOG_POST&ENTITY_ID=$2",
					useNewStyle: true
				},
				{
					exp: /\/company\/personal\/log\/(\d+)\//gi,
					replace: "/mobile/log/?ACTION=CONVERT&ENTITY_TYPE_ID=LOG_ENTRY&ENTITY_ID=$1",
					useNewStyle: true
				},
				{
					exp: /\/company\/personal\/user\/(\d+)\//gi,
					replace: "/mobile/users/?user_id=$1",
					useNewStyle: true
				},
				{
					exp: /\/crm\/(deal|lead|company|contact)\/show\/(\d+)\//gi,
					replace: "/mobile/crm/$1/?page=view&$1_id=$2",
					useNewStyle: true
				}
			];

			var params = null;
			for (var i = 0; i < mobileRegReplace.length; i++)
			{
				var mobileLink = url.replace(mobileRegReplace[i].exp, mobileRegReplace[i].replace);
				if (mobileLink != url)
				{
					params = {
						url: mobileLink,
						bx24ModernStyle: mobileRegReplace[i].useNewStyle
					};
					break;
				}
			}

			return params;
		}
	};





})(window);
