<?
if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED !== true)
{
	die();
}

/**
 * Bitrix vars
 *
 * @var array $arParams
 * @var array $arResult
 * @var CBitrixComponent $this
 * @global CMain $APPLICATION
 * @global CUser $USER
 */

$arDefaultUrlTemplates404 = array(
	"application" => "#id/",
);

$arDefaultVariableAliases404 = array();

$arDefaultVariableAliases = array();

$arComponentVariables = array("id");

$SEF_FOLDER = "";
$arUrlTemplates = array();

if($arParams["SEF_MODE"] == "Y")
{
	$arVariables = array();

	$arUrlTemplates = CComponentEngine::MakeComponentUrlTemplates($arDefaultUrlTemplates404, $arParams["SEF_URL_TEMPLATES"]);
	$arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases404, $arParams["VARIABLE_ALIASES"]);

	$componentPage = CComponentEngine::ParseComponentPath(
		$arParams["SEF_FOLDER"],
		$arUrlTemplates,
		$arVariables
	);

	if(!$componentPage)
	{
		$componentPage = 'application';
	}

	CComponentEngine::InitComponentVariables(
		$componentPage,
		$arComponentVariables,
		$arVariableAliases,
		$arVariables
	);

	$SEF_FOLDER = $arParams["SEF_FOLDER"];
}
else
{
	$arVariables = array();

	$arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases, $arParams["VARIABLE_ALIASES"]);
	CComponentEngine::InitComponentVariables(false, $arComponentVariables, $arVariableAliases, $arVariables);

	$componentPage = "application";
}

$arParams['ID'] = intval($arVariables['id']);
if($arParams['ID'] <= 0)
{
	ShowError(GetMessage('REST_AL_ERROR_APP_NOT_FOUND'));
	return;
}

$arParams['DETAIL_URL'] = isset($arParams['DETAIL_URL']) ? trim($arParams['DETAIL_URL']) : '/marketplace/detail/#code#/';

if(isset($_REQUEST['control']) && check_bitrix_sessid())
{
	$APPLICATION->RestartBuffer();
	$APPLICATION->ShowCSS();
	$APPLICATION->ShowHeadScripts();

	switch($_REQUEST['control'])
	{
		case 'user_selector':
			$APPLICATION->IncludeComponent(
				"bitrix:intranet.user.selector.new", ".default", array(
					"MULTIPLE" => isset($_REQUEST['mult']) ? 'Y' : 'N',
					"NAME" => $_REQUEST['name'],
					"VALUE" => array(),
					"POPUP" => "Y",
					"ON_CHANGE" => $_REQUEST['onchange'],
					"SITE_ID" => SITE_ID,
					"SHOW_EXTRANET_USERS" => "NONE",
				), null, array("HIDE_ICONS" => "Y")
			);
		break;

		case 'access_selector':
			echo CJSCore::Init(array('access'), true);
		break;
	}

	require($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/main/include/epilog_after.php");
	die();
}

if(!CModule::IncludeModule("rest"))
{
	return;
}

$dbRes = \Bitrix\Rest\AppTable::getList(array(
	'filter' => array(
		'=ID' => $arParams['ID']
	),
	'select' => array('*', 'MENU_NAME' => 'LANG.MENU_NAME', 'MENU_NAME_DEFAULT' => 'LANG_DEFAULT.MENU_NAME')
));
$arApp = $dbRes->fetch();

if(
	is_array($arApp) && $arApp['ACTIVE'] == 'Y'
	&& !empty($arApp['CLIENT_ID'])
)
{
	$bHasAccess = \CRestUtil::isAdmin();

	if (!$bHasAccess)
	{
		if(!empty($arApp["ACCESS"]))
		{
			$rights = explode(",", $arApp["ACCESS"]);
			$bHasAccess = $USER->CanAccess($rights);
		}
		else
		{
			$bHasAccess = true;
		}
	}

	$arResult['APP_NAME'] = $arApp['MENU_NAME'];
	if(strlen($arResult['APP_NAME']) <= 0)
	{
		$arResult['APP_NAME'] = $arApp['MENU_NAME_DEFAULT'];
	}

	if ($bHasAccess && strlen($arResult['APP_NAME']) > 0)
	{
		$arResult['APP_ID'] = $arApp['CLIENT_ID'];
		$arResult['APP_VERSION'] = $arApp['VERSION'];
		$arResult['APP_INSTALLED'] = $arApp['INSTALLED'] == 'Y';
		$arResult['APP_CODE'] = $arApp['CODE'];

		// common application options set via setAppOption
		$arResult['APP_OPTIONS'] = COption::GetOptionString("rest", "options_".$arResult['APP_ID'], "");
		if(strlen($arResult['APP_OPTIONS']) > 0)
			$arResult['APP_OPTIONS'] = unserialize($arResult['APP_OPTIONS']);
		else
			$arResult['APP_OPTIONS'] = array();

	// user application options set via setUserOption
		$arResult['USER_OPTIONS'] = CUserOptions::GetOption("app_options", "options_".$arResult['APP_ID'], array());

	// additional user application params set by app environment
		$arAppParams = CUserOptions::GetOption("app_options", "params_".$arResult['APP_ID']."_".$arResult['APP_VERSION'], array());

	// this is a first run for the application and the current user
		$arResult['FIRST_RUN'] = !array_key_exists('install', $arAppParams) || !$arAppParams['install'];

		$arResult['AUTH'] = \Bitrix\Rest\OAuth\Auth::get(
			$arApp['CLIENT_ID'],
			$arApp['SCOPE'],
			array(),
			$USER->GetID()
		);

		if(!is_array($arResult['AUTH']) || !$arResult['AUTH']['access_token'])
		{
			if($arResult['AUTH']['error'])
			{
				if(
					$arResult['AUTH']['error'] == 'ERROR_OAUTH'
					&& $arResult['AUTH']['error_description'] == 'Application not installed'
				)
				{
					$queryFields = array(
						'CLIENT_ID' => $arApp['CLIENT_ID'],
						'VERSION' => $arApp['VERSION'],
					);

					$installResult = \Bitrix\Rest\OAuthService::getEngine()
						->getClient()
						->installApplication($queryFields);

					if($installResult['result'])
					{
						$arResult['AUTH'] = \Bitrix\Rest\OAuth\Auth::get(
							$arApp['CLIENT_ID'],
							$arApp['SCOPE'],
							array(),
							$USER->GetID()
						);
					}
				}

				if($arResult['AUTH']['error'])
				{
					if($arResult['AUTH']['error'] !== "PAYMENT_REQUIRED")
					{
						ShowError($arResult['AUTH']['error'].($arResult['AUTH']['error_description'] ? ': '.$arResult['AUTH']['error_description'] : ''));
						return;
					}
					else
					{
						\Bitrix\Rest\AppTable::updateAppStatusInfo();

						$dbRes = \Bitrix\Rest\AppTable::getList(array(
							'filter' => array(
									'=ID' => $arParams['ID']
							),
							'select' => array('*', 'MENU_NAME' => 'LANG.MENU_NAME', 'MENU_NAME_DEFAULT' => 'LANG_DEFAULT.MENU_NAME')
						));
						$arApp = $dbRes->fetch();
					}
				}
			}
		}

		$dateFinish = $arApp['DATE_FINISH'] ? $arApp['DATE_FINISH']->getTimestamp() : '';
		if(
			!$arResult['AUTH']['error']
			&& (
				$arResult['AUTH']['status'] !== $arApp['STATUS']
				|| $arResult['AUTH']['date_finish'] != $dateFinish
			)
		)
		{
			$arApp['STATUS'] = $arResult['AUTH']['status'];
			$arApp['DATE_FINISH'] = $arResult['AUTH']['date_finish'] ? \Bitrix\Main\Type\Date::createFromTimestamp($arResult['AUTH']['date_finish']) : '';

			\Bitrix\Rest\AppTable::update($arApp['ID'], array(
				'STATUS' => $arApp['STATUS'],
				'DATE_FINISH' => $arApp['DATE_FINISH'],
			));
		}

		$arResult['DETAIL_URL'] = str_replace("#code#", $arApp['CODE'], $arParams['DETAIL_URL']);

		$arResult['APP_STATUS'] = \Bitrix\Rest\AppTable::getAppStatusInfo($arApp, $arResult['DETAIL_URL']);

		$arResult['APP_NEED_REINSTALL'] = $arApp['STATUS'] == \Bitrix\Rest\AppTable::STATUS_PAID && !isset($arApp['SHARED_KEY']);

		$arResult['APP_SID'] = md5(uniqid(rand(), true));

		$arResult['IS_ADMIN'] = \CRestUtil::isAdmin();
		$arResult['REST_PATH'] = \Bitrix\Main\Config\Option::get("rest", "server_path", "/rest");

		if(!is_array($arResult['AUTH']) || $arResult['AUTH']['error'])
		{
			$arResult['APP_STATUS']['PAYMENT_ALLOW'] = 'N';
		}

	// additional actions
		if($arResult['APP_STATUS']['PAYMENT_ALLOW'] == 'Y' && isset($_REQUEST['action']) && check_bitrix_sessid())
		{
			$APPLICATION->RestartBuffer();

			Header('Content-Type: application/json');

			switch($_REQUEST['action'])
			{
	// refresh auth
				case 'access_refresh':
					echo '{"access_token":"'.$arResult["AUTH"]['access_token'].'","refresh_token":"'.$arResult['AUTH']['refresh_token'].'","expires_in":"'.$arResult["AUTH"]['expires_in'].'"}';
				break;

	// set application option value
				case 'set_option':
					if($arResult['IS_ADMIN'])
					{
						if(is_array($_REQUEST['options']))
						{
							foreach($_REQUEST['options'] as $opt)
							{
								$arResult['APP_OPTIONS'][$opt['name']] = \Bitrix\Main\Text\Encoding::convertEncoding($opt['value'], 'utf-8', LANG_CHARSET);
							}
						}

						\Bitrix\Main\Config\Option::set("rest", "options_".$arResult['APP_ID'], serialize($arResult['APP_OPTIONS']));

						echo \Bitrix\Main\Web\Json::encode($arResult['APP_OPTIONS']);
					}
					else
					{
						echo '{"error":"access_denied"}';
					}

				break;

	// set installation finish flag
				case 'set_installed':
					if($arResult['IS_ADMIN'])
					{
						$updateResult = \Bitrix\Rest\AppTable::update(
							$arParams['ID'],
							array(
								'INSTALLED' => $_REQUEST['v'] == 'N' ? 'N' : 'Y'
							)
						);

						echo '{"result":"'.($updateResult->isSuccess()  ? 'true' : 'false').'"}';
					}
					else
					{
						echo '{"result":"false"}';
					}
				break;
			}

			die();
		}

	// get and parse application URL
		$arResult['APP_URL'] = $arApp['URL'];
		if(!$arResult['APP_INSTALLED'] && strlen($arApp['URL_INSTALL']) > 0)
		{
			if($arResult['IS_ADMIN'])
			{
				$arResult['INSTALL'] = true;
				$arResult['APP_URL'] = $arApp['URL_INSTALL'];
			}
			else
			{
				ShowError(GetMessage('REST_AL_ERROR_APP_NOT_INSTALLED'));
				return;
			}
		}
		elseif(
			(
				$arResult['APP_STATUS']['STATUS'] == \Bitrix\Rest\AppTable::STATUS_DEMO
				|| $arResult['APP_STATUS']['STATUS'] == \Bitrix\Rest\AppTable::STATUS_TRIAL
			)
			&& strlen($arApp['URL_DEMO']) > 0
		)
		{
			$arResult['APP_URL'] = $arApp['URL_DEMO'];
		}

		$arResult["APP_STATIC"] = \CRestUtil::isStatic($arResult['APP_URL']);

		$p = parse_url($arResult['APP_URL']);
		$arResult['APP_HOST'] = $p['host'];
		$arResult['APP_PROTO'] = $p['scheme'];

		if($p['port'])
		{
			$arResult['APP_HOST'] .= ':'.$p['port'];
		}

		$arResult['CURRENT_HOST_SECURE'] = \Bitrix\Main\Context::getCurrent()->getRequest()->isHttps();
		$arResult['CURRENT_HOST'] = $_SERVER['HTTP_HOST'];
		$arResult['MEMBER_ID'] = \CRestUtil::getMemberId();

		$updateVersion = intval(\Bitrix\Rest\Marketplace\Client::getAvailableUpdate($arApp["CODE"]));
		if(
			$updateVersion > $arApp['VERSION']
			&& !array_key_exists('skip_update_'.$updateVersion, $arAppParams)
		)
		{
			$arResult['UPDATE_VERSION'] = $updateVersion;
		}

		$APPLICATION->SetTitle($arResult['APP_NAME']);

		CJSCore::Init(array('ajax'));
		$this->IncludeComponentTemplate();
	}
	else
	{
		ShowError(GetMessage('REST_AL_ERROR_APP_NOT_FOUND'));
	}
}
else
{
	ShowError(GetMessage('REST_AL_ERROR_APP_NOT_FOUND'));
}
?>