<?
if(!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true)
	die();

if(!CModule::IncludeModule('rest'))
	return;

$bDesignMode = $GLOBALS["APPLICATION"]->GetShowIncludeAreas() && is_object($GLOBALS["USER"]) && $GLOBALS["USER"]->IsAdmin();
$GLOBALS["APPLICATION"]->SetShowIncludeAreas($bDesignMode);

$arDefaultUrlTemplates404 = array(
	"path" => "#method#",
);

$arDefaultVariableAliases404 = array();
$arDefaultVariableAliases = array();

$arComponentVariables = array(
	"method",
);

$arVariables = array();
$arQuery = array_merge($_GET, $_POST);

if($_SERVER['REQUEST_METHOD'] == 'POST' && count($_POST) <= 0)
{
	$postData = file_get_contents("php://input");

	if(strlen($postData) > 0)
	{
		$arPost = array();
		parse_str($postData, $arPost);
		$arQuery = array_merge($arQuery, $arPost);
	}
}

CUtil::decodeURIComponent($arQuery);

if($arParams["SEF_MODE"] == "Y")
{
	$arUrlTemplates = CComponentEngine::MakeComponentUrlTemplates($arDefaultUrlTemplates404, $arParams["SEF_URL_TEMPLATES"]);
	$arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases404, $arParams["VARIABLE_ALIASES"]);

	$componentPage = CComponentEngine::ParseComponentPath(
		$arParams["SEF_FOLDER"],
		$arUrlTemplates,
		$arVariables
	);

	CComponentEngine::InitComponentVariables("path", $arComponentVariables, $arVariableAliases, $arVariables);
}
else
{
	$arVariableAliases = CComponentEngine::MakeComponentVariableAliases($arDefaultVariableAliases, $arParams["VARIABLE_ALIASES"]);
	CComponentEngine::InitComponentVariables(false, $arComponentVariables, $arVariableAliases, $arVariables);

	unset($arQuery['method']);
}

if($arVariables['method'])
{
	$transport = 'json';
	$method = ToLower($arVariables['method']);
	$point = strrpos($method, '.');

	if($point > 0)
	{
		$check = substr($method, $point+1);
		if(CRestServer::transportSupported($check))
		{
			$transport = $check;
			$method = substr($method, 0, $point);
		}
	}

	$server = new CRestServer(array(
		"CLASS" => $arParams["CLASS"],
		"METHOD" => $method,
		"TRANSPORT" => $transport,
		"QUERY" => $arQuery,
	));

	$result = $server->process();

	if(!$bDesignMode)
	{
		$APPLICATION->RestartBuffer();

		$server->sendHeaders();
		echo $server->output($result);

		CMain::FinalActions();
		die();
	}
	else
	{
		echo '<pre>',htmlspecialcharsbx($server->output($result)),'</pre>';
	}
}
?>