CREATE TABLE IF NOT EXISTS b_rest_event
(
	ID int(11) NOT NULL AUTO_INCREMENT,
	APP_ID int(11) NOT NULL,
	EVENT_NAME varchar(255) NOT NULL ,
	EVENT_HANDLER varchar(255) NOT NULL,
	USER_ID int(11) NULL DEFAULT 0,
	PRIMARY KEY (ID),
	UNIQUE ux_b_rest_event_app_event (APP_ID, EVENT_NAME(100), EVENT_HANDLER(200), USER_ID),
	INDEX ix_b_rest_event_app_id (APP_ID),
	INDEX ix_b_rest_event_event_name (EVENT_NAME)
);

CREATE TABLE IF NOT EXISTS b_rest_app
(
	ID INT(11) NOT NULL AUTO_INCREMENT,
	CLIENT_ID VARCHAR(128) NOT NULL,
	CODE VARCHAR(128) NOT NULL,
	ACTIVE CHAR(1) NOT NULL DEFAULT 'Y',
	INSTALLED CHAR(1) NOT NULL DEFAULT 'N',
	URL VARCHAR(1000) NOT NULL,
	URL_DEMO VARCHAR(1000) NULL,
	URL_INSTALL VARCHAR(1000) NULL,
	VERSION VARCHAR(4) NULL DEFAULT '1',
	SCOPE VARCHAR(2000) NOT NULL,
	STATUS CHAR(1) NOT NULL DEFAULT 'F',
	DATE_FINISH DATE NULL,
	IS_TRIALED CHAR(1) NULL DEFAULT 'N',
	SHARED_KEY VARCHAR(32) NULL DEFAULT NULL,
	CLIENT_SECRET VARCHAR(100) NULL DEFAULT NULL,
	APP_NAME VARCHAR(1000) NULL DEFAULT NULL,
	ACCESS VARCHAR(2000) NULL DEFAULT '',
	APPLICATION_TOKEN VARCHAR(50) NULL DEFAULT '',
	MOBILE CHAR(1) NULL DEFAULT 'N',
	PRIMARY KEY (ID),
	UNIQUE INDEX ux_b_rest_app1 (CLIENT_ID)
);

CREATE TABLE IF NOT EXISTS b_rest_app_lang
(
	ID INT(11) NOT NULL AUTO_INCREMENT,
	APP_ID INT(11) NOT NULL,
	LANGUAGE_ID CHAR(2) NOT NULL,
	MENU_NAME VARCHAR(500) NULL,
	PRIMARY KEY (ID),
	UNIQUE INDEX ux_b_rest_app_lang1 (APP_ID, LANGUAGE_ID)
);
