CREATE TABLE B_SOCIALSERVICES_USER
(
	ID INT NOT NULL IDENTITY (1, 1),
	LOGIN VARCHAR(100) NOT NULL,
	NAME VARCHAR(100) NULL,
	LAST_NAME VARCHAR(100) NULL,
	EMAIL VARCHAR(100) NULL,
	PERSONAL_PHOTO INT NULL,
	EXTERNAL_AUTH_ID VARCHAR(100) NOT NULL,
	USER_ID INT NOT NULL,
	XML_ID VARCHAR(100) NOT NULL,
	CAN_DELETE CHAR(1) NOT NULL,
	PERSONAL_WWW VARCHAR(100) NULL,
	PERMISSIONS VARCHAR(555) NULL,
	OATOKEN VARCHAR(1000) NULL,
	OATOKEN_EXPIRES INT NULL,
	OASECRET VARCHAR(250) NULL,
	REFRESH_TOKEN VARCHAR(1000) NULL,
	SEND_ACTIVITY CHAR(1) NULL,
	SITE_ID VARCHAR(50) NULL,
	INITIALIZED CHAR(1) NULL
)
GO
ALTER TABLE B_SOCIALSERVICES_USER ADD CONSTRAINT PK_B_SOCIALSERVICES_USER PRIMARY KEY (ID)
GO
ALTER TABLE B_SOCIALSERVICES_USER ADD CONSTRAINT DF_B_SOCIALSERVICES_USER_CAN_DELETE DEFAULT 'Y' FOR CAN_DELETE
GO
ALTER TABLE B_SOCIALSERVICES_USER ADD CONSTRAINT DF_B_SOCIALSERVICES_USER_SEND_ACTIVITY DEFAULT 'Y' FOR SEND_ACTIVITY
GO
ALTER TABLE B_SOCIALSERVICES_USER ADD CONSTRAINT DF_B_SOCIALSERVICES_USER_INITIALIZED DEFAULT 'N' FOR INITIALIZED
GO
CREATE UNIQUE INDEX IX_B_SOCIALSERVICES_USER ON B_SOCIALSERVICES_USER(XML_ID, EXTERNAL_AUTH_ID)
GO
CREATE INDEX IX_B_SOCIALSERVICES_US_1 ON B_SOCIALSERVICES_USER(USER_ID)
GO
CREATE INDEX IX_B_SOCIALSERVICES_US_3 ON B_SOCIALSERVICES_USER(LOGIN)
GO

CREATE TABLE B_SOCIALSERVICES_MESSAGE (
	ID INT NOT NULL IDENTITY (1, 1),
	USER_ID INT NOT NULL,
	SOCSERV_USER_ID INT NOT NULL,
	PROVIDER VARCHAR(100) NOT NULL,
	MESSAGE VARCHAR(1000) NULL,
	INSERT_DATE DATETIME NULL,
	SUCCES_SENT CHAR(1) NOT NULL CONSTRAINT DF_B_SOCIALSERVICES_MESSAGE_SUCCES_SENT DEFAULT 'N'
)
GO
ALTER TABLE B_SOCIALSERVICES_MESSAGE ADD CONSTRAINT PK_B_SOCIALSERVICES_MESSAGE PRIMARY KEY (ID)
GO

CREATE TABLE B_SOCIALSERVICES_USER_LINK
(
	ID INT NOT NULL IDENTITY (1, 1),
	USER_ID INT NOT NULL,
	SOCSERV_USER_ID INT NOT NULL,
	LINK_USER_ID INT NULL,
	LINK_UID VARCHAR(100) NOT NULL,
	LINK_NAME VARCHAR(255) NULL,
	LINK_LAST_NAME VARCHAR(255) NULL,
	LINK_PICTURE VARCHAR(255) NULL,
	LINK_EMAIL VARCHAR(255) NULL,
	TIMESTAMP_X DATETIME NULL
)
GO

ALTER TABLE B_SOCIALSERVICES_USER_LINK ADD CONSTRAINT PK_B_SOCIALSERVICES_USER_LINK PRIMARY KEY (ID)
GO
