<?
/**
 * @access private
 */

namespace Bitrix\Tasks\Integration\SocialNetwork;

use Bitrix\Socialnetwork\WorkgroupTable;
use Bitrix\Tasks\Util\User;

class Group extends \Bitrix\Tasks\Integration\SocialNetwork
{
	const ACTION_VIEW_OWN_TASKS =   'view';
	const ACTION_VIEW_ALL_TASKS =   'view_all';
	const ACTION_CREATE_TASKS =     'create_tasks';
	const ACTION_EDIT_TASKS =       'edit_tasks';
	const ACTION_DELETE_TASKS =     'delete_tasks';

	public static function can($id, $actionCode, $userId = 0)
	{
		if(!static::includeModule())
		{
			return false; // no module = what groups?
		}

		if(!$userId)
		{
			$userId = User::getId();
		}

		return \CSocNetFeaturesPerms::canPerformOperation(
			$userId, SONET_ENTITY_GROUP,
			$id, 'tasks', $actionCode
		);
	}

	public static function getData(array $groupIds)
	{
		if(!static::includeModule() || empty($groupIds))
		{
			return array(); // no module = no groups
		}

		$result = array();

		// todo: make static caches here
		$res = WorkgroupTable::getList(array('filter' => array('ID' => $groupIds)));
		while($item = $res->fetch())
		{
			$result[$item['ID']] = $item;
		}

		return $result;
	}

	public static function updateLastActivity($id)
	{
		$id = intval($id);

		if(!static::includeModule() || !$id)
		{
			return false;
		}

		\CSocNetGroup::setLastActivity($id);

		return true;
	}

	public static function extractPublicData(array $group)
	{
		$safe = array(
			'NAME' => $group['NAME'],
		);

		if(intval($group['ID']))
		{
			$safe['ID'] = intval($group['ID']);
		}

		return $safe;
	}
}