<?
/**
 * Bitrix Framework
 * @package bitrix
 * @subpackage tasks
 * @copyright 2001-2016 Bitrix
 */

namespace Bitrix\Tasks\Item\Context;

use Bitrix\Tasks\Item\Result;

class Access
{
	public static function getActionMap()
	{
		return array(
			'CREATE',
			'READ',
			'UPDATE',
			'DELETE',
		);
	}

	public function __call($name, array $arguments)
	{
		static $map;

		$name = trim((string) $name);

		if($name != '')
		{
			if(strpos($name, 'can') === 0)
			{
				$action = substr($name, 3);
				if($action != '')
				{
					$action = ToUpper($action);

					if(!$map)
					{
						$map = array_flip(static::getActionMap());
					}

					if(isset($map[$action]))
					{
						return $this->testAction($action, $arguments[0]);
					}

					return true; // unknown action is allowed
				}
			}
		}
	}

	/**
	 * Return runtime field for datamanager query, that will check access rights
	 *
	 * @param $instance
	 * @return array
	 */
	public function getQueryRuntime($instance)
	{
		return array();
	}

	/**
	 * By default, everything is allowed
	 *
	 * @param $action
	 * @param $instance
	 * @return Result
	 */
	protected function testAction($action, $instance)
	{
		$result = new Result();

		if($action == 'READ')
		{
			// DO NOT USE $instance->getData() here, unless you want endless recursion
			// find out about readability by some other way
		}

		return $result;
	}
}