<?
/**
 * Bitrix Framework
 * @package bitrix
 * @subpackage tasks
 * @copyright 2001-2016 Bitrix
 *
 * THIS IS AN EXPERIMENTAL CLASS, DONT EXTEND
 *
 * @access private
 */

namespace Bitrix\Tasks\Manager\Task;

use \Bitrix\Tasks\Util\Error\Collection;

abstract class Member extends \Bitrix\Tasks\Manager
{
	public static function getLegacyFieldName()
	{
		return '';
	}

	public static function adaptSet(array &$data)
	{
		$from = static::getCode(true);
		$to = static::getLegacyFieldName();

		if(array_key_exists($from, $data))
		{
			if(!is_array($data[$to]))
			{
				$data[$to] = array();
			}

			if(static::getIsMultiple())
			{
				$items = \Bitrix\Tasks\Util\Type::normalizeArray($data[$from]);
				foreach($items as $item)
				{
					$data[$to][] = intval($item['ID']);
				}
			}
			else
			{
				$data[$to] = intval($data[$from]['ID']);
			}
		}
	}

	public static function formatSet(array &$data)
	{
		$from = static::getLegacyFieldName();
		$to = static::getCode(true);

		if(static::getIsMultiple())
		{
			$items = \Bitrix\Tasks\Util\Type::normalizeArray($data[$from]);
			foreach($items as $item)
			{
				$data[$to][] = array('ID' => intval($item));
			}
		}
		else
		{
			$data[$to] = array('ID' => intval($data[$from]));
		}
	}

	public static function extendData(array &$data, array $knownMembers = array())
	{
		$code = static::getCode(true);

		if(!array_key_exists($code, $data))
		{
			static::formatSet($data);
		}

		if(static::getIsMultiple())
		{
			$data[$code] = \Bitrix\Tasks\Util\Type::normalizeArray($data[$code]);
			foreach($data[$code] as $k => $item)
			{
				if(isset($knownMembers[$item['ID']]))
				{
					$data[$code][$k] = \Bitrix\Tasks\Util\User::extractPublicData($knownMembers[$item['ID']]);
				}
				else
				{
					// user might be is about to invite, do not erase
					//unset($data[$code][$k]);
				}
			}
		}
		else
		{
			if(isset($knownMembers[$data[$code]['ID']]))
			{
				$data[$code] = \Bitrix\Tasks\Util\User::extractPublicData($knownMembers[$data[$code]['ID']]);
			}
			else
			{
				// user might be is about to invite, do not erase
				//$data[$code] = array();
			}
		}
	}

	public static function inviteMembers(array &$data, Collection $errors)
	{
		$code = static::getCode(true);

		if(array_key_exists($code, $data) && is_array($data[$code]))
		{
			if(static::getIsMultiple())
			{
				foreach($data[$code] as $i => $user)
				{
					if(!intval($user['ID']))
					{
						if((string) $user['EMAIL'] != '' && \check_email($user['EMAIL']))
						{
							$data[$code][$i]['ID'] = static::inviteUser($user, $errors);
						}
						else
						{
							unset($data[$code][$i]); // bad structure
						}
					}
				}
			}
			else
			{
				$user =& $data[$code];

				if((string) $user['EMAIL'] != '' && \check_email($user['EMAIL']))
				{
					$user['ID'] = static::inviteUser($user, $errors);
				}
				else
				{
					$user = array(); // bad structure
				}
			}
		}
	}

	private static function inviteUser($user, Collection $errors)
	{
		$newId = \Bitrix\Tasks\Integration\Mail\User::create($user);
		if($newId)
		{
			return $newId;
		}
		else
		{
			$errors->add('USER_INVITE_FAIL', 'User has not been invited');
		}

		return false;
	}
}