CREATE TABLE B_XDI_LF_SCHEME
(
	ID INT NOT NULL IDENTITY (1, 1),
	LID CHAR(2) NOT NULL,
	TYPE VARCHAR(100) NOT NULL,
	NAME VARCHAR(255) NOT NULL,
	SORT INT,
	ACTIVE CHAR(1),
	AUTO CHAR(1),	
	ENABLE_COMMENTS CHAR(1),
	DAYS_OF_MONTH VARCHAR(100),
	DAYS_OF_WEEK VARCHAR(15),
	TIMES_OF_DAY VARCHAR(255),
	LAST_EXECUTED DATETIME,
	HOST VARCHAR(255),	
	PORT VARCHAR(5),	
	PAGE VARCHAR(255),
	URI TEXT NULL,
	METHOD VARCHAR(255),
	PARAMS VARCHAR(255),
	LOGIN VARCHAR(255),
	PASSWORD VARCHAR(255),
	ENTITY_TYPE VARCHAR(100) NOT NULL,
	ENTITY_ID INT NOT NULL,
	EVENT_ID VARCHAR(100) NOT NULL,
	HASH VARCHAR(32),
	IS_HTML CHAR(1)
)
GO
ALTER TABLE B_XDI_LF_SCHEME ADD CONSTRAINT PK_B_XDI_LF_SCHEME PRIMARY KEY (ID)
GO
ALTER TABLE B_XDI_LF_SCHEME ADD CONSTRAINT DF_B_XDI_LF_SCHEME_SORT DEFAULT 100 FOR SORT
GO
ALTER TABLE B_XDI_LF_SCHEME ADD CONSTRAINT DF_B_XDI_LF_SCHEME_ACTIVE DEFAULT 'Y' FOR ACTIVE
GO
ALTER TABLE B_XDI_LF_SCHEME ADD CONSTRAINT DF_B_XDI_LF_SCHEME_AUTO DEFAULT 'N' FOR AUTO
GO
ALTER TABLE B_XDI_LF_SCHEME ADD CONSTRAINT DF_B_XDI_LF_SCHEME_ENABLE_COMMENTS DEFAULT 'Y' FOR ENABLE_COMMENTS
GO
ALTER TABLE B_XDI_LF_SCHEME ADD CONSTRAINT DF_B_XDI_LF_SCHEME_ENTITY_ID DEFAULT 0 FOR ENTITY_ID
GO
ALTER TABLE B_XDI_LF_SCHEME ADD CONSTRAINT DF_B_XDI_LF_SCHEME_IS_HTML DEFAULT 'N' FOR IS_HTML
GO

CREATE TABLE B_XDI_LF_SCHEME_RIGHT
(
	SCHEME_ID INT NOT NULL,
	GROUP_CODE VARCHAR(100) NOT NULL
)
GO
CREATE UNIQUE INDEX UX_B_LF_SCHEME_RIGHT ON B_XDI_LF_SCHEME_RIGHT (SCHEME_ID, GROUP_CODE)
GO


CREATE TABLE B_XDI_USER_RIGHT
(
	USER_ID INT NOT NULL,
	GROUP_CODE VARCHAR(100) NOT NULL
)
GO
CREATE UNIQUE INDEX UX_B_XDI_USER_RIGHT ON B_XDI_USER_RIGHT (USER_ID, GROUP_CODE)
GO
