CREATE TABLE b_xdi_lf_scheme
(
	ID NUMBER(18) NOT NULL,
	LID CHAR(2 CHAR) NOT NULL,
	TYPE VARCHAR(100 CHAR) NOT NULL,
	NAME VARCHAR(255 CHAR) NOT NULL,
	SORT NUMBER(18) DEFAULT '100' NOT NULL,
	ACTIVE CHAR(1 CHAR) DEFAULT 'Y' NOT NULL,
	AUTO CHAR(1 CHAR) DEFAULT 'N' NOT NULL,	
	ENABLE_COMMENTS CHAR(1 CHAR) DEFAULT 'Y' NOT NULL,
	DAYS_OF_MONTH VARCHAR(100 CHAR),
	DAYS_OF_WEEK VARCHAR(15 CHAR),
	TIMES_OF_DAY VARCHAR(255 CHAR),
	LAST_EXECUTED DATE NULL,	
	HOST VARCHAR(255 CHAR),
	PORT VARCHAR(5 CHAR),
	PAGE VARCHAR(255 CHAR),
	URI CLOB NULL,
	METHOD VARCHAR(255 CHAR),
	PARAMS VARCHAR(255 CHAR),
	LOGIN VARCHAR(255 CHAR),
	PASSWORD VARCHAR(255 CHAR),
	ENTITY_TYPE VARCHAR(100 CHAR) NOT NULL,
	ENTITY_ID NUMBER(18) default '0' NOT NULL,	
	EVENT_ID VARCHAR(100 CHAR) NOT NULL,
	HASH VARCHAR(32 CHAR) NULL,	
	IS_HTML CHAR(1 CHAR) DEFAULT 'N',
	CONSTRAINT PK_B_XDI_LF_SCHEME PRIMARY KEY (ID)
)
/
CREATE SEQUENCE sq_b_xdi_lf_scheme
/
CREATE OR REPLACE TRIGGER b_xdi_lf_scheme_insert
BEFORE INSERT
ON b_xdi_lf_scheme
FOR EACH ROW
BEGIN
	IF :NEW.ID IS NULL THEN
		SELECT sq_b_xdi_lf_scheme.NEXTVAL INTO :NEW.ID FROM dual;
	END IF;
END;
/

CREATE TABLE b_xdi_lf_scheme_right
(
	SCHEME_ID NUMBER(18) NOT NULL,
	GROUP_CODE VARCHAR(100 CHAR) NOT NULL
)
/
CREATE UNIQUE INDEX UX_B_LF_SCHEME_RIGHT on b_xdi_lf_scheme_right (SCHEME_ID, GROUP_CODE)
/

CREATE TABLE b_xdi_user_right
(
	USER_ID NUMBER(18) NOT NULL,
	GROUP_CODE VARCHAR(100 CHAR) NOT NULL
)
/
CREATE UNIQUE INDEX UX_B_XDI_USER_RIGHT on b_xdi_user_right (USER_ID, GROUP_CODE)
/
